#ifndef AARRAY_H
#define AARRAY_H

#include <global.h> /* Tmp */

struct aarray {
    int len;
    int alloc;
    int eltsize;
    char *contents;
};

#define aget(vbl, a, i) (aget1((void *)&(vbl), (a), (i)))
#define aput(vbl, a, i) (aput1((void *)&(vbl), (a), (i)))
#define apush(vbl, a)   (apush1((void *)&(vbl), (a)))
#define atop(vbl, a)    (atop1((void *)&(vbl), (a)))
#define apop(vbl, a)    (apop1((void *)&(vbl), (a)))
  
#define alen(a) (((struct aarray *)(a))->len)
#define acontents(a) ((void *)(a)->contents)

#define aref(a, k) \
((void *)(Tmp.i = (k), \
          Tmp.i < 0 || Tmp.i >= (a)->len \
	  ? (char *) error("aref: Out of bounds") \
          : (a)->contents + Tmp.i * (a)->eltsize))

#define arefh(a, i) (*(short*)aref((a), (i)))
#define arefi(a, i) (*(int*)aref((a), (i)))
#define arefl(a, i) (*(long*)aref((a), (i)))
#define areff(a, i) (*(float*)aref((a), (i)))
#define arefd(a, i) (*(double*)aref((a), (i)))

void aget1 (void *xp, struct aarray *a, int i);
void aput1 (void *xp, struct aarray *a, int i);
int apush1 (void *xp, struct aarray *a);
int atop1 (void *xp, struct aarray *a);
int apop1 (void *xp, struct aarray *a);

void *aelt (struct aarray *a, int i);
int aid (struct aarray *a, void *x);
void *aneed (struct aarray *a, int i);
void *apull (struct aarray *a);
void *aallocate (struct aarray *a, int len);
void azero (struct aarray *a);
void agrow (struct aarray *a, int newalloc);
void asetlength (struct aarray *a, int newlen);
void agrowlength (struct aarray *a, int newlen);
struct aarray *make_aarray (int alloc, int eltsize);
void free_aarray (struct aarray *a);
void write_aarray (struct aarray *a, FILE *file);
struct aarray *read_aarray (FILE *file);
void dump_aarray (struct aarray *a, int (*print_elt)(), FILE *file);
void save_aarray (struct aarray *a, char *filename);
struct aarray *load_aarray (char *filename);
void save_as_array (struct aarray *a, char *filename);
struct aarray *load_as_aarray (char *filename, int alloc, int eltsize);

#endif /* AARRAY_H */

