#include <stdio.h>
#include <stdlib.h>
#include "global.h"
#include "error.h"


int TotalUserAllocation = 0;


void *allocate1 (char **loc, int n, int eltsize)
{
    int alloc = n * eltsize;
    char *bytes = (char *) malloc((unsigned) alloc);
    if (bytes == NULL) {
	error("allocate1: Trying to allocate %d bytes\n\
Total User Allocation = %d bytes\n", alloc, TotalUserAllocation);
    }
    *loc = bytes;
    bzero(bytes, alloc);
    TotalUserAllocation += alloc;
    return bytes;
}


void reallocate1 (char **loc, int *alloc_loc, int n, int eltsize)
{
    int old_alloc = *alloc_loc * eltsize, new_alloc = n * eltsize;
    char *bytes = (char *) realloc(*loc, (unsigned) new_alloc);

    if (bytes == NULL) {
	error("reallocate1: Trying to reallocate %d bytes to %d bytes\n\
Total User Allocation = %d bytes\n", old_alloc, new_alloc, TotalUserAllocation);
    }
    *loc = bytes;
    *alloc_loc = n;
    if (new_alloc > old_alloc)
      bzero(bytes + old_alloc, new_alloc - old_alloc);
    TotalUserAllocation += new_alloc - old_alloc;
}


void deallocate1 (void *x, int n, int eltsize)
{
    TotalUserAllocation -= n * eltsize;
    free(x);
}
