#include <stdio.h>
#include <sys/types.h>
#include <global.h>
#include <spaconf.h>
#include <allocate.h>
#include <textio.h>
#include <random.h>


char *bdup (char *b, int sz)
{
    char *c;

    allocate(c, sz, char);
    bcopy(b, c, sz);
    return c;
}


static int BrandInit = 0;


char *brandom (void *b, int n)
{
    int i;
    t_randnum x;

    if (!BrandInit) {
        randomize();
	BrandInit = 1;
    }
    for (i = 0; i < n; i++) {
        if (i%sizeof(t_randnum) == 0) {
            x = randnum();
	}
        ((char*)b)[i] = ((char *) &x)[i%sizeof(t_randnum)];
    }
    return b;
}


void print_binary (char *bytes, int len, FILE *file)
{
    int i = 0, j;
    
    while (1) {
	if (len == 0) {if (bytes[i] == '\0') break;}
	else {if (i == len) break;}
	if (i != 0) write_string("  ", file);
	for (j = 7; j >= 0; j--) {
	    if (bytes[i] & (1 << j))
	      write_char('1', file);
	    else
	      write_char('0', file);
	    if (j == 4) write_char(' ', file);
	}
	i++;
    }
}


char *make_bit_array (int n)
{
    char *bits;

    allocate(bits, (n-1)/8+1, char);
    return bits;
}
