#ifndef BYTES_H
#define BYTES_H

#include <global.h> /* Tmp */

#define GET(flags, flag)   ((flags) & (flag))
#define SET(flags, flag)   ((flags) |= (flag))
#define UNSET(flags, flag) ((flags) &= ~(flag))

char *bdup (char *b, int sz);
char *brandom (void *b, int n);

void print_binary (char *bytes, int len, FILE *file);
char *make_bit_array (int n);

#define zero_bit_array(a,n) (bzero((a),((n)-1)/8+1))

#define getbit(a,k) \
  (Tmp.i = (k), \
   ((char *)(a))[Tmp.i/8] & 1 << Tmp.i%8)

#define setbit(a,k) \
  (Tmp.i = (k), \
   ((char *)(a))[Tmp.i/8] |= 1 << Tmp.i%8)

#define unsetbit(a,k) \
  (Tmp.i = (k), \
   ((char *)(a))[Tmp.i/8] &= ~(1 << Tmp.i%8))

#endif
