
#ifdef DEBUG

#define Trace_M_start \
if (MatchVerbose) { \
    terpri(stdout); \
    indent(stdout); \
    printf("Match level %d\n", CurrentLevel); \
    push_indent(2); \
}


#define Trace_M_loop \
if (MatchVerbose) { \
    terpri(stdout); \
    indent(stdout); \
    printf("(Re)Start\n"); \
    indent(stdout); \
    printf("  "); \
    print_subchart(start, SentLen+1, stdout); \
    terpri(stdout); \
    indent(stdout); \
    printf("  %d", s); \
}


#define Trace_M_nil \
if (MatchVerbose) { \
    printf(" NIL %d\n", s); \
}


#define Trace_M_unrecognized \
if (MatchVerbose) { \
    if (in->cat == 0) printf(" (no cat)"); \
    else printf(" %s (not local)", symbol_string(in->cat)); \
}


#define Trace_M_next \
if (MatchVerbose) { \
    printf(" %s %d", symbol_string(in->cat), s); \
}


#define Trace_M_finals \
if (MatchVerbose) { \
    int *f; \
    printf("(F="); \
    for (f = finals; *f; f++) { \
        if (f != finals) print_char(',', stdout); \
	print_string(symbol_string(*f), stdout); \
    } \
    print_char(')', stdout); \
}


#define Trace_M_match \
if (MatchVerbose) { \
    terpri(stdout); \
    indent(stdout); \
    printf("Match <%s %d %d>\n", symbol_string(cmax), start, jmax); \
}


#define Trace_M_punt \
if (MatchVerbose) { \
    terpri(stdout); \
    indent(stdout); \
    printf("Punt <%s %d %d>\n", in->cat ? symbol_string(in->cat) : "no cat", start, in->j); \
}


#define Trace_M_done \
if (MatchVerbose) { \
    pop_indent(); \
}


#define Trace_P_start \
if (MatchVerbose) { \
    indent(stdout); \
    printf("Parse <%s %d %d>\n", \
	   symbol_string(cat), start, end); \
    push_indent(2); \
}


#define Trace_P_noparse \
if (MatchVerbose) { \
    indent(stdout); \
    printf("No actions/fst\n"); \
}


#define Trace_P_iv \
if (MatchVerbose) { \
    int I; \
    indent(stdout); \
    printf("iv=["); \
    for (I = ILocals; I < NLocals; I++) { \
	if (I > ILocals) printf(" "); \
	printf("%d", iv[I]); \
    } \
    printf("]\n"); \
}


#define Trace_P_right \
if (MatchVerbose) { \
    indent(stdout); \
    printf("Exec %d=%s], c=<%s - %d>\n", \
	   e, symbol_string(local_cat(e)), symbol_string(local_cat(e)), iv[e]); \
}


#define Trace_P_left \
if (MatchVerbose) { \
    indent(stdout); \
    printf("Exec [, iv[%d]=%d, Chart[%d]=", e, iv[e], iv[e]); \
    print_phrase(c, stdout); \
    printf(" c="); \
    print_phrase(p, stdout); \
    printf("\n"); \
}


#define Trace_P_assign \
if (MatchVerbose) { \
    indent(stdout); \
    printf("Exec =, ftr=%d(%s %s), iv[%d]=%d, child=Chart[%d]=", \
	   f, local_string(e), att_string(f), e, iv[e], iv[e]); \
    print_phrase(Chart[iv[e]], stdout); \
    printf(" c="); \
    print_phrase(c, stdout); \
    printf("\n"); \
}


#define Trace_P_end \
if (MatchVerbose) { \
    indent(stdout); \
    printf("Chart[%d] = ", start); \
    print_phrase(p, stdout); \
    printf(", next start=%d\n", end); \
    pop_indent(); \
}


#define Trace_FEP_start \
if (MatchVerbose) { \
    int I; \
    indent(stdout); \
    printf("FST = %d\n", CurrentFsa); \
    indent(stdout); \
    printf("ELocals:"); \
    for (I = ILocals+1; I <= NLocals; I++) { \
	printf(" %d(%s)", I, local_string(I)); \
    } \
    printf(", Chart: ["); \
    for (I = start; I < end; I = Chart[I]->j) { \
        if (I > start) printf(" "); \
	printf("%d %s", I, symbol_string(Chart[I]->cat)); \
    } \
    printf(" %d]\n", I); \
}
    

#define Trace_FEP_stack_1 \
    int I; \
    indent(stdout); \
    for (I = 0; I <= top; I++) { \
	if (I > 0) printf(" "); \
	printf("%d", stack[I].s); \
        if (stack[I].local > 0) { \
            if (stack[I].local <= ILocals) { \
                printf(" %s", symbol_string(Chart[stack[I].i]->cat)); \
            } \
	    else { \
		printf(" %d(%s)", stack[I].local, local_string(stack[I].local)); \
	    }  \
	} \
    }


#define Trace_FEP_backtrack \
if (MatchVerbose) { \
    Trace_FEP_stack_1; \
    printf(" -- backtrack\n"); \
}


#define Trace_FEP_success \
if (MatchVerbose) { \
    Trace_FEP_stack_1; \
    printf(" -- success\n"); \
}


#define Trace_FEP_done 


#else


#define Trace_M_start 
#define Trace_M_loop 
#define Trace_M_nil 
#define Trace_M_unrecognized 
#define Trace_M_next 
#define Trace_M_match 
#define Trace_M_punt 
#define Trace_M_done
#define Trace_P_start
#define Trace_P_noparse
#define Trace_P_iv
#define Trace_P_right
#define Trace_P_left
#define Trace_P_assign
#define Trace_P_end
#define Trace_FEP_start 
#define Trace_FEP_stack_1 
#define Trace_FEP_backtrack 
#define Trace_FEP_success 


#endif
