#ifndef DEFAULTS_H
#define DEFAULTS_H

#include <stdlib.h>     /* for getenv() */
#include <spaconf.h>    /* for DEFAULTS_FILE */
#include <global.h>     /* for Tmp */

#define DONT_OVERRIDE   0
#define OVERRIDE        1
#define DRY_RUN         2
#define IGNORE_NONEXIST 4

#define read_defaults() \
  (read_default_file(DEFAULTS_FILE, DONT_OVERRIDE|IGNORE_NONEXIST), \
   DefaultsRead = 1)

#define getdefault(s)  (DefaultsRead ? 0 : read_defaults(), getenv(s))
#define getdefaulti(s) ((Tmp.p = getdefault(s)) == NULL ? 0 : atoi(Tmp.p))
#define getdefaultf(s) ((Tmp.p = getdefault(s)) == NULL ? 0.0 : atof(Tmp.p))

#define defaults(vbl,s) ((Tmp.p = getdefault(s)) == NULL ? 0 : ((vbl) = Tmp.p))
#define defaulti(vbl,s) ((Tmp.p = getdefault(s)) == NULL ? 0 : ((vbl) = atoi(Tmp.p)))
#define defaultf(vbl,s) ((Tmp.p = getdefault(s)) == NULL ? 0 : ((vbl) = atof(Tmp.p)))

extern int DefaultsRead;
extern int DefaultsVerbose;

int read_default_file (char *filename, int override);


#endif
