#ifndef DICT_H
#define DICT_H

struct dict_node {
    int bit;
    int left;
    int right;
    char *key;
};


struct dict {
    struct dict_node *nodes;
    int count;
    int alloc;
};


#define DICT_STATE_STACKSIZE 128

struct dict_state {
  int stack[DICT_STATE_STACKSIZE];
  char term[DICT_STATE_STACKSIZE];
  int depth;
  struct dict *dict;
};


#define pat_key(i,d) ((d)->nodes[i].key)

extern struct dict *Dict;

int make_node (char *key, int bit);
int pat_search (char *key, struct dict *d);
int pat_search_1 (char *key);
int pat_insert (char *key, struct dict *d);
struct dict *scan_dict (FILE *file);
int pat_encode (struct dict *d, FILE *infile, FILE *outfile);
int pat_encode_fields (int *flds, int len, struct dict *d, FILE *infile, FILE *outfile);
int pat_decode (struct dict *d, FILE *infile, FILE *outfile);
int pat_decode_fields (int *flds, int len, struct dict *d, FILE *infile, FILE *outfile);
struct dict *make_dict (int alloc);
void free_dict (struct dict *d);
void write_dict (struct dict *d, FILE *file);
struct dict *read_dict (FILE *file);
int dict_size (char *filename);
void dump_dict (struct dict *d, FILE *file);
void print_dict_keys (struct dict *d, FILE *file);
void save_dict (struct dict *d, char *filename);
struct dict *load_dict (char *filename);
int dict_start (struct dict_state *state, struct dict *d);
int dict_next (int *kp, char **sp, struct dict_state *S);
int subdict_start (struct dict_state *state, int p, struct dict *d);


#endif /* DICT_H */
