/**
***  These are widely used macros and external variables that I don't
***  have any more convenient place to put.
**/


#ifndef GGLOBAL_H
#define GGLOBAL_H


#ifdef DOS
#include <mem.h>
#define bzero(b,n) (memset(b,0,n))
#define bcopy(b1,b2,n) (memcpy(b2,b1,n))
#endif /* DOS */

#ifdef NO_BZERO
#include <memory.h>
#define bzero(b,n) (memset(b,0,n))
#define bcopy(b1,b2,n) (memcpy(b2,b1,n))
#define bcmp(b1,b2,n) (memcmp(b1,b2,n))
#endif /* NO_BZERO */

#define NIL 0
#define EOL -1

extern int new_entry_p;

typedef union {
    char c;
    short h;
    int i;
    long l;
    float f;
    double d;
    long double D;
    char *s;
    void *p;
} GENERIC;

extern GENERIC Tmp, Tmp1, Tmp2;

#ifdef UNIX
#define offsetof(structtype,slot) \
  ((unsigned int) ((char*)&((struct structtype *) NULL)->slot - (char*)NULL))
#endif
#define lengthof(array) ((unsigned int) (sizeof(array)/sizeof(array[0])))

typedef int (*function)();

#endif
