#ifndef HASH_H
#define HASH_H

struct hash_table {
    int size;
    int length;
    int keysize;
    int valsize;
    char *keys;
    char *present;
    char *values;
};

extern int HashVerbose;

struct hash_table *make_hash_table (int size, int keysize, int valsize);
int free_hash_table (struct hash_table *table);
void print_hash_table_header (struct hash_table *table, FILE *file);
void dump_hash_table (struct hash_table *table, FILE *file);
void *gethash (void *key, struct hash_table *table);
void *needhash (void *key, struct hash_table *table);
void *sethash (void *key, void *value, struct hash_table *table);
void maphash (int (*f)(), struct hash_table *table);

int write_hash_table (struct hash_table *t, FILE *file);
struct hash_table *read_hash_table (FILE *file);

#endif

