#include <stdio.h>
#include <spafile.h>


/**
***  I'd like to make all these macros, and change the syntax for read_int etc,
***  but I'll do that another time.
**/

int scan_int_1 (int *i, FILE *file)
{
    int n = fscanf(file, "%d", i);
    if (n == 0) error("scan_int_1: Non-numeric input");
    else return n;
}

int scan_short_1 (short *i, FILE *file)
{
    int n = fscanf(file, "%hd", i);
    if (n == 0) error("scan_short_1: non-numeric input");
    return n;
}

int scan_long_1 (long *i, FILE *file)
{
    int n = fscanf(file, "%ld", i);
    if (n == 0) error("scan_long_1: Non-numeric data in input");
    else return n;
}

int scan_float_1 (float *f, FILE *file)
{
    int n = fscanf(file, "%f", f);
    if (n == 0) error("scan_float_1: Non-numeric data in input");
    else return n;
}

int scan_double_1 (double *f, FILE *file)
{
    int n = fscanf(file, "%lf", f);
    if (n == 0) error("scan_double_1: Non-numeric input");
    return n;
}

int scan_longdbl_1 (long double *f, FILE *file)
{
    int n = fscanf(file, "%Lf", f);
    if (n == 0) error("scan_longdbl_1: non-numeric input");
    return n;
}

int print_int_1 (int *x, FILE *file)
{
    fprintf(file, "%d", *x);
}

int print_short_1 (short *x, FILE *file)
{
    fprintf(file, "h %hd", *x);
}

int print_long_1 (long *x, FILE *file)
{
    fprintf(file, "l %ld", *x);
}

int print_float_1 (float *x, FILE *file)
{
    fprintf(file, "%f", *x);
}

int print_double_1 (double *x, FILE *file)
{
    fprintf(file, "d %lf", *x);
}

int print_longdbl_1 (long double *x, FILE *file)
{
    fprintf(file, "D %Lf", *x);
}

int print_ptr_1 (void **x, FILE *file)
{
    fprintf(file, "*%d", *x);
}

int write_int (int i, FILE *file)
{
    return fwrite((char *) &i, sizeof(int), 1, file);
}

int write_long (long i, FILE *file)
{
    fwrite((char *) &i, sizeof(long), 1, file);
}

int write_float (double i, FILE *file)
{
    fwrite((char *) &i, sizeof(double), 1, file);
}

void save_array1 (char *a, int len, int eltsize, char *filename)
{
    FILE *file = Fopen(filename, "w");
    fwrite(a, eltsize, len, file);
    fclose(file);
}


void load_array1 (char **a, int *len, int eltsize, char *filename)
{
    int size = file_size(filename);
    FILE *file = Fopen(filename, "r");
    
    if (size % eltsize != 0)
      error("%d not a multiple of %d", size, eltsize);
    allocate1(a, size, 1);
    *len = size / eltsize;
    fread(*a, 1, size, file);
    fclose(file);
}
