#ifndef IO_H
#define IO_H


int scan_int_1 (int *i, FILE *file);
int scan_short_1 (short *x, FILE *file);
int scan_long_1 (long *i, FILE *file);
int scan_float_1 (float *f, FILE *file);
int scan_double_1 (double *x, FILE *file);
int scan_longdbl_1 (long double *x, FILE *file);

int print_int_1 (int *x, FILE *file);
int print_short_1 (short *x, FILE *file);
int print_long_1 (long *x, FILE *file);
int print_float_1 (float *x, FILE *file);
int print_double_1 (double *x, FILE *file);
int print_longdbl_1 (long double *x, FILE *file);
int print_ptr_1 (void **x, FILE *file);

#define read_int(i, file) ((fread((char *) &(i), sizeof(int), 1, (file)) == 0) ? EOF : 1)
int write_int (int i, FILE *file);
#define scan_int(i, file) scan_int_1(&(i), (file))
#define print_int(i, file) (fprintf(file, "%d", i))

#define read_long(i, file) ((fread((char *) &(i), sizeof(long), 1, (file)) == 0) ? EOF : 1)
int write_long (long i, FILE *file);
#define scan_long(i, file) scan_long_1(&(i), (file))
#define print_long(i, file) (fprintf(file, "%ld", i))

#define read_float(i, file) ((fread((char *) &(i), sizeof(double), 1, (file)) == 0) ? EOF : 1)
int write_float (double i, FILE *file);
#define scan_float(i, file) scan_float_1(&(i), (file))
#define print_float(i, file) (fprintf(file, "%lf", i))

#define read_struct(s, type, file) \
  ((fread((char *) (s), sizeof(type), 1, (file)) == 0) ? EOF : 1)

#define write_struct(s, type, file) \
  fwrite((char *) (s), sizeof(type), 1, (file))

#define read_array(a, n, elttype, file) \
  ((fread((char *) (a), sizeof(elttype), (n), (file)) == 0) ? EOF : 1)

#define write_array(a, n, elttype, file) \
  fwrite((char *) (a), sizeof(elttype), (n), (file))

#define save_array(a, n, elttype, file) \
  save_array1(a, n, sizeof(elttype), file)
void save_array1 (char *a, int len, int eltsize, char *filename);

#define load_array(a, n, elttype, file) \
  load_array1(&a, &n, sizeof(elttype), file)
void load_array1 (char **a, int *len, int eltsize, char *filename);

#define read_bytes(a, n, file) \
  ((fread((char *) (a), 1, (n), (file)) == 0) ? EOF : 1)

#define write_bytes(a, n, file) \
  fwrite((char *) (a), 1, (n), (file))

#endif
