
#ifndef LIST_STORE_H
#define LIST_STORE_H

#include <global.h>  /* Tmp */

/**
***  The beginning index (in lists) of the i-th list is hdr[i].
***  The length of the i-th list is hdr[i+1] - hdr[i].
**/

#define lref(a, i) \
  (aref((a)->lists, arefi((a)->hdr, (i))))

/**
***  The reason for TmpLLENj is that, technically, evaluation of
***  operands can be interleaved, so that there must be no side
***  effects in one operand that could affect the result of the
***  other.  The macro arefi does an assignment; if the two calls
***  to arefi are interleaved, we're in deep doodoo.
**/

#define llen(a, i) \
  (Tmp1.i = (i), \
   Tmp2.i = arefi((a)->hdr, Tmp1.i+1), \
   Tmp2.i - arefi((a)->hdr, Tmp1.i))

#define list_count(a) \
  (alen((a)->hdrs)-1)

struct list_store {
    struct aarray *hdr;
    struct aarray *lists;
};

struct list_store *  make_list_store   (int nlists, int nelts, int eltsize);
void *               lallocate         (int nelts, struct list_store *s);
int                  write_list_store  (struct list_store *s, FILE *file);
struct list_store *  read_list_store   (FILE *file);

#endif
