
#ifndef LISTS_H
#define LISTS_H

#include <global.h> /* Tmp */
#include <aarray.h>

typedef int ConsId;

#define make_consarray(alloc) \
  make_aarray((alloc)*2, sizeof(int))

#define carptr(c) \
  (Tmp.i = (c), Tmp.i <= 0 ? 0 : (int *) aref(Cells, Tmp.i-1))
#define car(c) *carptr(c)

#define cdrptr(c) \
  (Tmp.i = (c), Tmp.i <= 0 ? 0 : (int *) aref(Cells, Tmp.i))
#define cdr(c) *cdrptr(c)

#define cvrptr(c) \
  (Tmp.i = (c), Tmp.i <= 0 ? 0 : (int *) aref(Cells, Tmp.i+1))
#define cvr(c) *cvrptr(c)

#define caar(c) (car(car(c)))
#define cadr(c) (car(cdr(c)))
#define cdar(c) (cdr(car(c)))
#define first(c) (car(c))
#define second(c) (cadr(c))
#define push(x, loc) (Tmp.p = (loc), *(int*)Tmp.p = cons((x), *(int*)Tmp.p))

#define let_cells(cells) \
{ \
  struct aarray *let_cells_prevCells = Cells; \
  Cells = (cells);

#define end_let_cells \
  Cells = let_cells_prevCells; \
}

extern struct aarray *Cells;
int cons (int a, int d);
int acons (int k, int v, int d);
int *assoc (int key, int s);
int *nassoc (int key, int *loc);
int *nassocs (int key, int *loc);
int nreverse (int s);
int list (int elt, ...);
void print_list (int a, FILE *file);
void print_alist (int a, FILE *file);
void describe_consarray (struct aarray *a, FILE *file);
void dump_aconsarray (struct aarray *a, FILE *file);


#endif /* LISTS_H */
