#!/bin/sh

cat > spaconf.h <<EOF
#ifndef SPACONF_H
#define SPACONF_H
#define SLHOME "$1"
#define SLSRC "$2"
#define SLRELEASE $3
#define SLVERSION $4
#define DEFAULTS_FILE "$5"
#define DEFAULT_DATAPATH "$6"
#define DEFAULT_FX_FILE "$7"
#define DEFAULT_CASS_GRAMMAR "$8"
#define DEFAULT_TUPLE_SPECS "$9"
EOF

OS=`uname -s`
REL=`uname -r`

case "$OS" in
SunOS) case "$REL" in
       [5-9]*) NEED_BCMP=1; USE_RAND=1;;
       esac
       ;;
esac

if [ ! -z "$NEED_BCMP" ]
then
cat >> spaconf.h <<EOF
#include <memory.h>
#define bzero(b,n) (memset(b,0,n))
#define bcopy(b1,b2,n) (memcpy(b2,b1,n))
#define bcmp(b1,b2,n) (memcmp(b1,b2,n))
EOF
fi

if [ -z "$USE_RAND" ]
then
cat >> spaconf.h <<EOF
#include <sys/time.h>
#define randomize() (srandom(time(NULL)))
#define randnum random
typedef long t_randnum;
EOF

else
cat >> spaconf.h <<EOF
#include <sys/time.h>
#define randomize() (srand(time(NULL)))
#define randnum rand
typedef int t_randnum;
EOF
fi

cat >> spaconf.h <<EOF
#endif
EOF
