#ifndef OBJECT_H
#define OBJECT_H


struct object {
    TypeId type;
    union {
	char c;
	short h;
	int i;
	long l;
	float f;
	double d;
	long double D;
	char *s;
	void *p;
    } data;
};


#define type_string(t)      (TypeStrings[t])
#define type_size(t)        (TypeSizes[t])
#define print_type(t,file)  (print_string(type_string(t), (file)))

int istype (char *s);
int type_from_size (int size);

extern char **TypeStrings;
extern int *TypeSizes;


int istype (char *s);
int type_from_size (int size);
int print_object (struct object *o, FILE *file);
int dump_object (struct object *o, FILE *file);
TypeId data_file_type (char *filename);
struct object *read_object (TypeId t, FILE *file);
struct object *load_data_file (char *filename);


#endif
