#ifndef RBTREE_H
#define RBTREE_H

#include <global.h> /* Tmp */

struct tnode {
  int key;
  int left;
  int right;
};

struct tstore {
  struct aarray *nodes;
  struct aarray *colors;
};

struct tree_state {
  int stack[64];
  char nstate[64];
  int depth;
};

extern struct tstore *TStore;

extern struct tstore *TStoreStack[32];
extern int TStoreStackDepth;

#define push_tstore(ts) \
(TStoreStackDepth >= 32 ? error("push_tstore: stack overflow") : 0, \
 TStoreStack[TStoreStackDepth++] = TStore, \
 TStore = (ts))

#define pop_tstore() \
(TStoreStackDepth <= 0 ? error("pop_tstore: empty stack") : 0, \
 TStore = TStoreStack[--TStoreStackDepth])

extern int TMarkStack[32];
extern int TMarkDepth;

#define push_tmark() \
(TMarkStack[TMarkDepth < 32 ? TMarkDepth++ : error("push_tmark: stack overflow")] \
 = TStore->nodes->len)

#define pop_tmark() \
(azero_to(TMarkStack[TMarkDepth > 0 ? --TMarkDepth : error("pop_tmark: empty stack")], \
	  TStore->nodes), \
 azero_to((TMarkStack[TMarkDepth]+7)/8, TStore->colors))

#define Tlist_start(state, tree, tstore) \
  (push_tstore(tstore), Tmp.i = tlist_start(state, tree), pop_tstore(), Tmp.i)

#define Tlist_next(kp, state, tstore) \
  (push_tstore(tstore), Tmp.i = tlist_next(kp, state), pop_tstore(), Tmp.i)

#define Tlist_last(kp, tree, tstore) \
  (push_tstore(tstore), Tmp.i = tlist_last(kp, tree), pop_tstore(), Tmp.i)

#define Tinsert(key, loc, tstore) \
  (push_tstore(tstore), Tmp.i = tinsert(key, loc), pop_tstore(), Tmp.i)

#define tsearch(key, t) (Tsearch((key), (t), TStore))

#define print_Tlist(t, tstore, file) \
  (push_tstore(tstore), print_tlist((t), (file)), pop_tstore())

#define tlist_length(t) (Tlist_length(t,TStore))

struct tstore *make_tstore (int alloc);
struct tstore *zero_tstore (struct tstore *tstore);
int tinsert (int key, int *loc);
int Tsearch (int key, int t, struct tstore *tstore);
int dump_tstore (struct tstore *tstore, FILE *file);
int scan_tree (FILE *file);
int tlist_start (struct tree_state *state, int tree);
int tlist_next (int *kp, struct tree_state *state);
int tlist_last (int *kp, int t);
int Tlist_length (int t, struct tstore *tstore);
int print_tlist (int tree, FILE *file);
int tnunion (int *tp1, int t2);
#define Tnunion tnunion1
int tnunion1 (int *tp1, struct tstore *tstore1, int t2, struct tstore *tstore2);

int write_tstore (struct tstore *tstore, FILE *file);
struct tstore *read_tstore (FILE *file);


#endif
