
int RegTraceRX;

#ifdef DEBUG

#define Trace_Stack \
if (RegTraceRX) { \
    printf("\n  "); \
    for (i = 0; i <= top; i++) { \
	print_node(&stack[i], stdout); \
	printf(" "); \
    } \
    printf("/ "); \
    print_node(&la, stdout); \
    printf("\n"); \
}


#define Trace_Macro \
if (RegTraceRX) { \
    printf("  Expand macro %s -> [term %d %d]\n", \
	   symbol_string(stack[top].v), lp, rp); \
}


#define Trace_Term \
if (RegTraceRX) { \
    if (t == STRING) \
      printf("  Reduce [string %s] to [term %d %d], lit=%d, tag=%d (%s:%s)\n", \
	     lit_string(lit), lp, rp, lit, tag, tag_string(tag), tag_type_string(tag)); \
    else \
      printf("  Shift, Reduce COLON/LBRACKET [string %s] to [term %d %d], lit=%d, tag=%d (%s:%s)\n", \
	     lit_string(lit), lp, rp, lit, tag, tag_string(tag), tag_type_string(tag)); \
}


#define Trace_ShEq \
if (RegTraceRX) printf("  Shift EQUALS\n")


#define Trace_ReEq \
if (RegTraceRX) \
    printf("  Reduce [term %d %d] EQUALS [%s %d %d] to [%s %d %d]\n", \
	   lcl, lcr, type_name(t), rcl, rcr, type_name(t), pl, pr)



#define Trace_Star \
if (RegTraceRX) { \
    printf("  Shift, Reduce [term %d %d] QMARK/STAR/PLUS to [term %d %d]\n", \
	   cl, cr, pl, pr); \
}


#define Trace_Seq \
if (RegTraceRX) { \
    printf("  Reduce [seq/term %d %d] [term %d %d] to [seq %d %d]\n", \
	   lcl, lcr, rcl, rcr, pl, pr); \
}


#define Trace_Lparen \
if (RegTraceRX) { \
    printf("  Shift STRING/LPAREN\n"); \
}


#define Trace_Rparen \
if (RegTraceRX) { \
    printf("  Shift, Reduce TERM -> LPAREN ALT/SEQ/TERM RPAREN\n"); \
}


#define Trace_Alt \
if (RegTraceRX) { \
    printf("  Reduce [alt/seq/term %d %d] VBAR [seq/term %d %d] to [alt %d %d]\n", \
	   lcl, lcr, rcl, rcr, pl, pr); \
}


#define Trace_Vbar \
if (RegTraceRX) printf("  Shift VBAR\n")

      
#define Trace_Accept \
if (RegTraceRX) { \
    printf("  Accept %s, lit=%d, tag=%d\n", symbol_string(Cat), eos, lit_tag(eos)); \
    print_regex(rx, stdout); \
}

#else

#define Trace_Stack
#define Trace_Macro
#define Trace_Term
#define Trace_ShEq
#define Trace_ReEq
#define Trace_Star
#define Trace_Seq
#define Trace_Lparen
#define Trace_Rparen
#define Trace_Alt
#define Trace_Vbar
#define Trace_Accept

#endif
