
int RegTraceTM = 0;


#ifdef DEBUG


#define Trace_start \
if (RegTraceTM) { \
    printf("\n"); \
    indent(stdout); \
    printf("Build Transition Matrix\n"); \
    push_indent(2); \
}
    

#define Trace_state \
if (RegTraceTM) { \
    indent(stdout); \
    printf("State %d, litset=", i+1); \
    print_Tlist(lits, TmpTstore1, stdout); \
    printf("\n"); \
    push_indent(2); \
}


#define Trace_output \
if (RegTraceTM) { \
    indent(stdout); \
    printf("Lit %d, Tag %d=$%s, finals=", lit, tag, tag_string(tag)); \
    print_Tlist(finals, TmpTstore1, stdout); \
    printf("\n"); \
}


#define Trace_input \
if (RegTraceTM) { \
    indent(stdout); \
    printf("Lit %d, Tag %d=%s%s, next_lits=", lit, tag, tag_pp_type(tag), tag_string(tag)); \
    print_Tlist(next_lits, PointTstore, stdout); \
    printf(", a[%d] = ", local); \
    print_Tlist(a[local], TmpTstore1, stdout); \
    printf("\n"); \
}


#define Trace_skip \
if (RegTraceTM) { \
    indent(stdout); \
    printf("Lit %d, Tag %d=%c%s, skipping\n", lit, tag, tag_pp_type(tag), tag_string(tag)); \
}


#define Trace_next \
if (RegTraceTM) { \
    indent(stdout); \
    printf("Converting a[%d] from ", local); \
    print_Tlist(lits, TmpTstore1, stdout); \
    printf(" to state %d", a[local]); \
    if (new_entry_p) printf(" (new)"); \
    printf("\n"); \
}


#define Trace_finals \
if (RegTraceTM) { \
    int TRACEi; \
    indent(stdout); \
    printf("Converting finals to array ["); \
    for (TRACEi = 0; TRACEi < nfinals; TRACEi++) { \
	if (TRACEi != 0) printf(" "); \
	printf("%d", fa[TRACEi]); \
    } \
    printf("]\n"); \
    pop_indent(); \
}


#define Trace_done \
if (RegTraceTM) { \
    printf("Done: %d states\n", NStates); \
    pop_indent(); \
}


#else

#define Trace_start
#define Trace_state
#define Trace_output
#define Trace_input
#define Trace_skip
#define Trace_next
#define Trace_finals
#define Trace_done

#endif
