
int RegShowPoints;
int RegShowLiterals;
int RegTraceRX;
int RegTraceTM;
int RegDumpParse;
char *DpFileName;
int DpPointNumbers, DpNodeNumbers, DpPlainText;
char *RegInFileName, *RegOutFileName;
FILE *RegOutFile;

#ifdef DEBUG

#define Trace_Features \
if (RegTraceRX) { \
    int fid; \
    struct feature *f; \
    printf("\nFeatures:"); \
    for (i = 1; i <= NFtrs; i++) { \
	f = get_ftr(i); \
	printf(" %d: %s/%d", i, symbol_string(f->cat), f->mode); \
    } \
    printf("\n"); \
    printf("\nSym2Ftr: "); \
    for (i = 1; i <= Reg->cats->count; i++) \
      if (fid = Sym2Ftr[i-1]) \
	printf(" %d %s -> %d ", i, symbol_string(i), fid); \
    printf("\n"); \
}



#define Trace_TM_start \
if (RegTraceTM) { \
    printf("\n"); \
    indent(stdout); \
    printf("Build Transition Matrix\n"); \
    push_indent(2); \
    print_regex(Regex, stdout); \
}
    

#define Trace_TM_state \
if (RegTraceTM) { \
    indent(stdout); \
    printf("State %d, litset=", i+1); \
    print_Tlist(lits, TmpTstore1, stdout); \
    printf("\n"); \
    push_indent(2); \
}


#define Trace_TM_output \
if (RegTraceTM) { \
    indent(stdout); \
    printf("Lit %d, Tag %d=$%s, finals=", lit, tag, tag_string(tag)); \
    print_Tlist(finals, TmpTstore1, stdout); \
    printf("\n"); \
}


#define Trace_TM_input \
if (RegTraceTM) { \
    indent(stdout); \
    printf("Lit %d, Tag %d=%s%s, next_lits=", lit, tag, tag_pp_type(tag), tag_string(tag)); \
    print_Tlist(next_lits, PointTstore, stdout); \
    printf(", a[%d] = ", local); \
    print_Tlist(a[local], TmpTstore1, stdout); \
    printf("\n"); \
}


#define Trace_TM_skip \
if (RegTraceTM) { \
    indent(stdout); \
    printf("Lit %d, Tag %d=%c%s, skipping\n", lit, tag, tag_pp_type(tag), tag_string(tag)); \
}


#define Trace_TM_next \
if (RegTraceTM) { \
    indent(stdout); \
    printf("Converting a[%d] from ", local); \
    print_Tlist(lits, TmpTstore1, stdout); \
    printf(" to state %d", a[local]); \
    if (new_entry_p) printf(" (new)"); \
    printf("\n"); \
}


#define Trace_TM_finals \
if (RegTraceTM) { \
    int TRACEi; \
    indent(stdout); \
    printf("Converting finals to array ["); \
    for (TRACEi = 0; TRACEi < nfinals; TRACEi++) { \
	if (TRACEi != 0) printf(" "); \
	printf("%d", fa[TRACEi]); \
    } \
    printf("]\n"); \
    pop_indent(); \
}


#define Trace_TM_done \
if (RegTraceTM) { \
    printf("Done: %d states\n", NStates); \
    pop_indent(); \
}


#else

#define Trace_SR_Stack
#define Trace_SR_Macro
#define Trace_SR_Term
#define Trace_SR_ShEq
#define Trace_SR_ReEq
#define Trace_SR_Star
#define Trace_SR_Seq
#define Trace_SR_Lparen
#define Trace_SR_Rparen
#define Trace_SR_Alt
#define Trace_SR_Vbar
#define Trace_SR_Accept
#define Trace_Features
#define Trace_TM_start
#define Trace_TM_state
#define Trace_TM_output
#define Trace_TM_input
#define Trace_TM_skip
#define Trace_TM_next
#define Trace_TM_finals
#define Trace_TM_done


#endif
