#ifndef FILECOMS_H
#define FILECOMS_H

#include <dirent.h>
#include <spaconf.h>


extern FILE *Fopen (char *path, char *mode);
#define Fclose(file) (fclose(file), (file = NULL))

extern FILE *TmpSPAfile;
extern int FopenErrNo;

#define open_file(path, mode) \
  (TmpSPAfile = fopen((path), (mode)), \
   FopenErrNo = errno, errno = 0, TmpSPAfile)

extern int file_exists_p (char *filename);
extern int file_size (char *filename);
extern time_t file_mtime (char *filename);
extern int rm (char *filename);

#define start_dir(dir,path) dir = opendir(path)

extern char *dir_next (DIR *dir);

#define end_dir(dir) closedir(dir)


#define BLOCKSIZE 1024  /* this is a guess; i haven't figured out how to find out */

extern int catenate (char **filenames, int nfiles, FILE *outfile);


extern char *DataPath1;
#define DataPath \
  (DataPath1 != NULL ? DataPath1 : \
   (DataPath1 = getenv("DATAPATH")) != NULL ? DataPath1 : (DataPath1 = DEFAULT_DATAPATH))

/* this is only a quarter of what the system permits, but I think it's plenty */
#define MAXFILENAME 256

#define ORELSE  0
#define NOERR 1

#define find_datafile(filename) \
  (find_filename(filename, DataPath))

extern char *find_filename (char *filename, char *path);
extern char *filesuf (char *filename);
extern int has_suf (char *filename, char *suf);
extern char *addsuf (char *filename, char *suf);
extern char *chsuf (char *filename, char *oldsuf, char *newsuf);
extern char *rmsuf (char *filename, char *suf);


#endif
