#ifndef TOK_H
#define TOK_H

#define MAX_TOKEN 127

/* null 0 */
#define STRING 1
#define LBRACE 2
#define RBRACE 3
#define COLON 4
#define SEMICOLON 5
#define COMMA 6
#define VBAR 7
#define STAR 8
#define PLUS 9
#define QMARK 10
#define LPAREN 11
#define RPAREN 12
#define EQUALS 13
#define ARROW 14
#define ATSIGN 15
#define LBRACKET 16
#define RBRACKET 17
#define HASH 18
#define PERCENT 19
#define BANG 20
#define DOLLAR 21
#define AMPERSAND 22
#define NTOKTYPES 23


struct tokstream {
    FILE *file;
    char *filename;
    int line;
    char token[MAX_TOKEN+1];
    int la;
};


char *toktype_string (int t);
int unscan_token (int type, struct tokstream *S);
int peek_token (struct tokstream *S);
int scan_token (struct tokstream *S);
int skip_whitespace_and_comments (FILE *file);
struct tokstream *make_tokstream (FILE *file);
struct tokstream *open_tokstream (char *filename);
int close_tokstream (struct tokstream *stream);

#endif
