#ifndef STRING_TABLE_H
#define STRING_TABLE_H


struct string_array {
  struct aarray *strings;
  struct aarray *chars;
};

struct string_array *make_string_array (int alloc);
void init_string_array (struct string_array *a, int alloc);
char *string_array_ref (struct string_array *a, int i);
int string_array_insert (char *s, struct string_array *a);
#define string_array_len(a) ((a)->strings->len)
void write_string_array (struct string_array *a, FILE *file);
void read_string_array (struct string_array *a, FILE *file);
int zero_string_array (struct string_array *a);


struct string_table {
  struct dict *d;
  struct string_array a;
};

#define string_table_len(tbl) ((tbl)->d->count)
struct string_table *scan_string_table (int alloc, FILE *file);
char *string_table_ref (char *s, struct string_table *tbl);
#define string_table_key(i, tbl) (pat_key((i), (tbl)->d))
#define string_table_value(i, tbl) (string_array_ref(&(tbl)->a, (i)))
void dump_string_table (struct string_table *tbl, FILE *file);
void write_string_table (struct string_table *tbl, FILE *file);
struct string_table *read_string_table (FILE *file);
void save_string_table (struct string_table *tbl, char *filename);
struct string_table *load_string_table (char *filename);

#endif

