#include <stdio.h>
#include "spa.h"
#include "dict.h"
#include "aarray.h"


struct table {
    struct dict *keys;
    struct aarray *values;
};


struct table *make_table (int nelts, int eltsize)
{
    struct table *t;

    allocate(t, 1, struct table);
    t->keys = make_dict(nelts);
    t->values = make_aarray(nelts, eltsize);
    return t;
}


#define tabneed(s,t) (aneed((t)->values, pat_insert((s),(t)->keys)))

void *tabget (char *s, struct table *t)
{
    int i = pat_search(s, t->keys);
    return i < 0 ? NULL : aref(t->values, i);
}
