#ifndef TAGFIXES_H
#define TAGFIXES_H


#include <dict.h>
#include <hash.h>

struct tagfixes {
  struct dict *dict;         /* words & cats */
  struct hash_table *hash;   /* cat word-code -> new-cat */
};

extern int TagFixesAlloc;
extern int KeepOldTags;
extern int WordsCaseSensitive;
extern int DowncaseInputTags;
extern int TagfixesSilent;
extern struct tagfixes *TagFixes;

struct tagfixes *scan_tagfixes (FILE *file);
char *fix_tag (char *tag, char *word);
int apply_tagfixes (struct tagfixes *fx, FILE *infile, FILE *outfile);
struct tagfixes *make_tagfixes (int alloc);
int write_tagfixes (struct tagfixes *fx, FILE *file);
struct tagfixes *read_tagfixes (FILE *file);
char *save_tagfixes (struct tagfixes *fx, char *path);
struct tagfixes *load_tagfixes (char *path);


#endif
