#include <stdio.h>
#include "spa.h"

struct tmatrix {
    int n;          /** number of rows/columns **/
    int N;          /** allocation: number of nonredundant cells **/
    int eltsize;
    char *a;        /** the array **/
};

void *tref (struct tmatrix *m, int i, int j)
{
    return (void *) (m->a + m->eltsize * (i*(2*m->n-3-i)/2 + j - 1));
}

struct tmatrix *make_tmatrix (int n, int eltsize)
{
    struct tmatrix *M;
    int N = n*(n-1)/2;

    allocate(M, 1, struct tmatrix);
    M->n = n;
    M->N = N;
    M->eltsize = eltsize;
    allocate(M->a, N * eltsize, char);
    return M;
}


write_tmatrix (struct tmatrix *m, FILE *file)
{
    write_int(m->n, file);
    write_int(m->N, file);
    write_int(m->eltsize, file);
    write_bytes(m->a, m->N, file);
}

struct tmatrix *read_tmatrix (FILE *file)
{
    struct tmatrix *m;

    allocate(m, 1, struct tmatrix);
    read_int(m->n, file);
    read_int(m->N, file);
    read_int(m->eltsize, file);
    allocate(m->a, m->N * m->eltsize, char);
    read_bytes(m->a, m->N * m->eltsize, file);
    return m;
}
