#ifndef XDICT_H
#define XDICT_H

#include <dict.h>
#include <aarray.h>

struct xdict {
    struct dict *d;
    struct aarray *a;
};

#define xdict_key(id, D) (pat_key((id)-1, (D)->d))
#define xdict_ref(D, id) (aref((D)->a, (id)-1))

int xdict_insert (char *key, struct xdict *D, void **entp);
int xdict_search (char *key, struct xdict *D, void **entp);
struct xdict *make_xdict (int alloc, int eltsize);
int free_xdict (struct xdict *D);
int write_xdict (struct xdict *D, FILE *file);
struct xdict *read_xdict (FILE *file);

#endif
