#include <stdio.h>
#include <spa.h>
#include <global.h>


bin_decode (file, pattern)
    FILE *file;
    char *pattern;
{
    int i, d, nfields = strlen(pattern);
    double f;

    while (1) {
	for (i = 0; i < nfields; i++) {
	    if (i != 0) print_char('\t', stdout);
	    switch (pattern[i]) {
	      case 'd':
		if (read_int(d, file) == EOF) return 1;
		print_int(d, stdout);
		break;
	      case 'f':
		if (read_float(f, file) == EOF) return 1;
		print_float(f, stdout);
		break;
	      default: error("Bad pattern: %s", pattern);
	    }
	}
	print_char('\n', stdout);
    }
}


bin_encode (file, pattern)
    FILE *file;
    char *pattern;
{
    int i, d, nfields = strlen(pattern);
    float f;
    
    while (1) {
	for (i = 0; i < nfields; i++) {
	    switch (pattern[i]) {
	      case 'd':
		if (scan_int(d, file) == EOF) return 1;
		write_int(d, stdout);
		break;
	      case 'f':
		if (scan_float(f, file) == EOF) return 1;
		write_float(f, stdout);
		break;
	      default: error("Bad pattern: %s", pattern);
	    }
	}
    }
}


main (int argc, char *argv[])
{
    int decode = 0;
    char *pattern = "d", *filename = NULL;
    FILE *file;

    ProgName = argv[0];
    SHIFT;
    while (argc > 0) {
	if (argv[0][0] == '+') {
	    pattern = argv[0]+1;
	    SHIFT;
	}
	else if (argv[0][0] == '-') {
	    if (argv[0][1] == 'd') {
		decode = 1;
		SHIFT;
	    }
	    else error("%s: Unrecognized flag %s", ProgName, argv[0]);
	}
	else {
	    if (filename != NULL) error("Sorry, can't handle multiple filenames");
	    filename = argv[0];
	    SHIFT;
	}
    }

    file = filename != NULL ? Fopen(filename, "r") : stdin;
    if (decode)
      bin_decode(file, pattern);
    else
      bin_encode(file, pattern);
    exit(0);
}
