#include <stdio.h>
#include <errno.h>
#include <stdarg.h>
#include <spa.h>
#include <dict.h>
#include <aarray.h>



typedef union stream *primfnc(int n, char *argv[]);

    
struct estrm {
    int t;
    union stream *in;
    union stream *buf;
    int la;
};

struct fstrm {
    int t;
    char *fname;
    int line;
    FILE *f;
    int la;
};

struct sstrm {
    int t;
    char *fname;
    int line;
    char *s;
    int i;
};
	
struct astrm {
    int t;
    char *fname;
    int line;
    struct aarray *a;
    int i;
};
    
struct ostrm {
    int t;
};

struct xstrm {
    int t;
    void *p;
};

union stream {
    struct fstrm f;
    struct estrm e;
    struct sstrm s;
    struct astrm a;
    struct ostrm o;
    struct xstrm x;
};

struct definition {
    int n;
    int *pa;
    char *mask;
    char *value;
};

struct binding {
    int sym;
    struct definition d;
};

struct form {
    int sym;
    struct definition *def;
    union stream **args;
};

struct params {
    int n;
    char *mask;
    int *pa;
};

struct number {
    int t;
    union {
	float f;
	int i;
    } v;
};

#define INTEGER 0
#define FLOAT   1



#include <smlsyntax.h>


char *SmlPath = ".";

#define MAXARGS 64
#define WORDMAX 128
#define STACKSIZE 256
#define FSTACKSIZE 64


union stream *InstreamStack[FSTACKSIZE];
int Id = 0;


struct dict *SymbolTable;
struct aarray *GlobalDefs;
int Trace = 0;
int Silent = 0;
int Raw = 0;
int NoRedirect = 0;
char *DocSuf = NULL;
char *Format = NULL;
struct form *CurrentlyScanning = NULL;

int TmpSMLi;
char *TmpSMLs;
struct form *TmpSMLform;
struct definition *TmpSMLdef;

char speek (union stream *S);
char sread (union stream *S);
void sunread (char c, union stream *S);
void swrite (char c, union stream *S);
void swrite_string (char *s, union stream *S);
int sunwrite_if (char c, union stream *S);
void scat (union stream *instream, union stream *outstream);
char *sstring (union stream *S);
char *SString (union stream *S);
union stream *sstream (char *s);
union stream *cstream (char c);
union stream *fstream (float f);
union stream *istream (int i);
int slen (union stream *S);
int snull (union stream *S);
int sreset (union stream *S);
char *sfilename (union stream *S);
int sline (union stream *S);
union stream *make_stream (int t, void *arg);
void sclose (union stream *S);
char parse_scan_mode (char *m);
int sml_error (char *fmt, ...);
unsigned char get_cookie (char *s);
void free_cookie (unsigned char c);
int toplevel_write (unsigned char c);
void toplevel_close ();
void write_special_string (unsigned char *s);
void flush_ws ();
void push_outfile (char *filename);
void pop_outfile ();
int prefetch (struct estrm *S);
union stream *sml_open (char *filename);
int sml_filter (char *filename);
union stream *sml_scan_term (union stream *instream);
union stream *sml_scan_term_tws (union stream *instream);
char *sml_scan_word (union stream *instream);
void sml_scan_comment (union stream *instream);
union stream *sml_expand (union stream *instream);
char *sml_reduce (union stream *S);
int defun1 (char *name, char *params, void *value, int prim);
int defvar (char *name, char *value);
int sml_intern (char *s);
int parse_parameters (struct params *p, char *params, int prim);
int sml_set_definition (struct definition *def, struct params *params, char *value);
char *form_fnc_string (struct form *form);
struct form *make_form (int symbol);
void sml_print_form (struct form *form, int width, FILE *file);
int sml_print_stream (union stream *S, int width, FILE *file);
int sml_print_string (char *s, int width, FILE *file);
int sml_print_char (unsigned char c, int *statep, FILE *file);
struct form *sml_scan_form (union stream *stream);
struct definition *lexical_definition (int sym);
struct definition *dynamic_definition (int sym);
int bind_sym (struct binding *b, int sym, char *params, char *value);
int free_env (struct binding *env);
struct definition *env_definition (int sym, struct binding *env);
struct definition *symbol_definition (int sym);
union stream *sml_eval (struct form *form);
int sml_print_env (struct binding *env, FILE *file);
int sml_print_environment (FILE *file);
union stream *pf_defun (int n, char *argv[]);
union stream *pf_defvar (int n, char *argv[]);
union stream *pf_envvar (int n, char *argv[]);
int sml_setx (char *s, void *v);
void *sml_symbol_value (char *s);
union stream *pf_set (int n, char *argv[]);
union stream *pf_setfun (int n, char *argv[]);
union stream *pf_upcase (int n, char *argv[]);
union stream *pf_showobj (int n, char *argv[]);
int sml_showobj (char *t, char *x);
union stream *pf_message (int n, char *argv[]);
int sml_string_fields (char *s, char **a, int len);
union stream *pf_array (int n, char *argv[]);
union stream *pf_aref (int n, char *argv[]);
union stream *pf_bind (int n, char *argv[]);
union stream *pf_bindf (int n, char *argv[]);
union stream *pf_unbind (int n, char *argv[]);
union stream *pf_eval (int n, char *argv[]);
union stream *pf_scanmode (int n, char *argv[]);
union stream *pf_pop_scanmode (int n, char *argv[]);
union stream *pf_system (int n, char *argv[]);
union stream *pf_date (int n, char *argv[]);
union stream *pf_print_to (int n, char *argv[]);
union stream *pf_appendto (int n, char *argv[]);
int append_lexical (int nbindings, int *symbols, char **values);
union stream *pf_dolist (int n, char *argv[]);
union stream *pf_collecting (int n, char *argv[]);
union stream *pf_collect (int n, char *argv[]);
union stream *pf_repeat (int n, char *argv[]);
union stream *pf_switch (int n, char *argv[]);
union stream *pf_file (int n, char *argv[]);
union stream *pf_unfile (int n, char *argv[]);
union stream *pf_if (int n, char *argv[]);
union stream *pf_ifelse (int n, char *argv[]);
union stream *pf_unless (int n, char *argv[]);
int defchar (char *command, char *value);
union stream *pf_defchar (int n, char *argv[]);
union stream *pf_defspecial (int n, char *argv[]);
union stream *pf_escape (int n, char *argv[]);
int atonum (struct number *num, char *s);
union stream *pf_plus (int n, char *argv[]);
union stream *pf_times (int n, char *argv[]);
union stream *pf_incr (int n, char *argv[]);
union stream *pf_include (int n, char *argv[]);
union stream *pf_firstword (int n, char *argv[]);
union stream *pf_restwords (int n, char *argv[]);
union stream *pf_quote (int n, char *argv[]);
union stream *pf_kill (int n, char *argv[]);
union stream *pf_error (int n, char *argv[]);
union stream *pf_equal (int n, char *argv[]);
union stream *pf_value (int n, char *argv[]);
union stream *pf_Format (int n, char *argv[]);
union stream *pf_mkdir (int n, char *argv[]);
union stream *pf_file_exists_p (int n, char *argv[]);
int sml_init ();
char *path_push (char *dir, char **pathp);
int main (int argc, char *argv[]);


#define push_instream(S) \
  (Id >= FSTACKSIZE ? sml_error("InstreamStack overflow") : (int)(InstreamStack[Id++] = (S)))

#define pop_instream() \
  (Id > 0 ? Id-- : sml_error("pop_instream: empty stack"))

#define Instream (Id > 0 ? InstreamStack[Id-1] : NULL)

#define symbol_name(sym) \
  (TmpSMLi = (sym), TmpSMLi == 0 ? "<null symbol>" : pat_key(TmpSMLi-1,SymbolTable))

#define REGULAR   0
#define PRIMITIVE 1

#define is_defined(def)  ((def)->n >= 0)

#define is_function(def) ((def)->mask != NULL)

#define is_primitive(def) \
  (TmpSMLdef = (def), \
   TmpSMLdef->mask != NULL && getbit(TmpSMLdef->mask, TmpSMLdef->n))

char *Specials[128] = {NULL};

    
#define PC_NEWLINES 1   /* interpret newlines */
#define PC_SPECIALS 2   /* mark specials */
#define PC_WESC     4   /* prev char was escape */


#define sml_expander(stream) (make_stream(ESTRM, (stream)))



/**===================================================================
***
***			       STREAMS
***  
***  char speek (union stream *S)
***  Peek a char from stream.
***  
***  char sread (union stream *S)
***  Read a char from stream.
***  
***  sunread (char c, union stream *S)
***  Put a char back onto stream.
***  
***  swrite (char c, union stream *S)
***  Write a char to stream.
***  
***  swrite_string (char *s, union stream *S)
***  Write a sequence of chars to stream.
***  
***  #define sunwrite(c,S)
***  Unwrite a char from stream.
***  
***  int sunwrite_if (char c, union stream *S)
***  No error if c or stream are null.
***  
***  scat (union stream *instream, union stream *outstream)
***  Copies stream1 until EOF onto stream2.  Destroys stream1.
***  
***  char *sstring (union stream *S)
***  Accesses string inside stream.  Do not modify the string.  The string
***  is good only until the stream is touched.
***  
***  char *SString (union stream *S)
***  Like sstring, but does not signal an error if S is bad,
***  returns a string describing S instead.
***  
***  union stream *sstream (char *s)
***  Creates a stream from a string.  Copies the string, does not consume it.
***  
***  union stream *cstream (char c)
***  Creates a stream from a character.
***  
***  union stream *fstream (float f)
***  Creates a stream that contains the printed representation of f.
***  
***  union stream *istream (int i)
***  Creates a stream that contains the printed representation of i.
***  
***  int slen (union stream *S)
***  Returns the length in characters of the stream.
***  
***  #define snull(S)
***  True just in case length of S is zero.
***  
***  int sreset (union stream *S)
***  Erases contents of stream.
***  
***  union stream *make_stream (int t, void *arg)
***  If t is FSTRM or PSTRM, arg should be a file.
***  If t is SSTRM, arg is the number of characters to allocate.
***  If t is ASTRM, arg is the initial allocation in chars.
***  
***  sclose (union stream *S)
***  Destroys a stream.  If S contains a file, the file is closed.  If it contains
***  a string, the string is freed.  If it contains an array, the array and each
***  element of the array are freed.
***  
***  smark (union stream *S)
***  Sets the stream's mark.  The mark is set each time a form is successfully
***  read from the stream.  That way, when an error occurs, it is possible to
***  determine where the form causing the error began.
**/



#define FSTRM 1     /* File */
#define SSTRM 2     /* String */
#define ASTRM 3     /* Adjustable string */
#define PSTRM 4     /* Pipe */
#define OSTRM 5     /* Outfile */
#define XSTRM 6     /* C object */
#define ARRAYSTRM 7 /* Array of strings */
#define ESTRM 8     /* Stream that expands directives */

struct ostrm Ostrm = {OSTRM};
union stream *Outstream = (union stream *) &Ostrm;


char speek (union stream *S)
{
    int c;
    
    if (S == NULL) return '\0';
    else if (S->f.t == FSTRM || S->f.t == PSTRM) {
	c = S->f.la ? S->f.la : peek_char(S->f.f);
	return c == EOF ? '\0' : c;
    }
    else if (S->f.t == SSTRM) {
	return S->s.s == NULL ? '\0' : S->s.s[S->s.i];
    }
    else if (S->f.t == ASTRM) {
	if (alen(S->a.a) > S->a.i) {
	    return *(char *) aref(S->a.a, S->a.i);
	}
	else return '\0';
    }
    else if (S->f.t == ESTRM) {
	prefetch(&S->e);	
	return S->e.la;
    }
    else sml_error("speek: can't read from this kind of stream");
}

/*
 * char sread1 (union stream *S);
 * 
 * sread (union stream *S)
 * {
 *     char c;
 * 
 *     indent(stdout);
 *     printf("Enter sread 0x%x\n", S);
 *     push_indent(2);
 *     c = sread1(S);
 *     pop_indent();
 *     indent(stdout);
 *     printf("Exit sread ");
 *     sml_print_char(c, 0, stdout);
 *     terpri(stdout);
 *     return c;
 * }
 */

char sread (union stream *S)
{
    int c;
    
    if (S == NULL) return '\0';
    else if (S->f.t == FSTRM || S->f.t == PSTRM) {
	if (S->f.la) {
	    c = S->f.la;
	    S->f.la = 0;
	}
	else {
	    c = read_char(S->f.f);
	    if (c == EOF) c = '\0';
	}
	if (c == '\n') S->f.line++;
	return c;
    }
    else if (S->f.t == ESTRM) {
	prefetch(&S->e);
	c = S->e.la;
	S->e.la = 0;
	return c;
    }
    else if (S->f.t == SSTRM) {
	c = S->s.s == NULL ? '\0' : S->s.s[S->s.i];
	if (c) {
	    S->s.i++;
	    if (c == '\n') S->s.line++;
	}
	return c;
    }
    else if (S->f.t == ASTRM) {
	if (alen(S->a.a) > S->a.i) {
	    c = *(char *) aref(S->a.a, S->a.i);
	    if (c) {
		S->a.i++;
		if (c == '\n') S->a.line++;
	    }
	    return c;
	}
	else return '\0';
    }
    else sml_error("sread: can't read from this kind of stream");
}


void sunread (char c, union stream *S)
{
    if (c == '\0') sml_error("sunread: can't unread null");
    else if (S == NULL) ;
    else if (S->f.t == FSTRM || S->f.t == PSTRM) {
	if (S->f.la) sml_error("Attempt to unread multiple chars");
	S->f.la = c;
	if (c == '\n') S->f.line--;
    }
    else if (S->f.t == ESTRM) {
	if (S->e.la) error("sunread: already char in buffer");
	S->e.la = c;
    }
    else if (S->f.t == SSTRM) {
	if (S->s.i <= 0) sml_error("sunread: no previous read");
	S->s.i--;
	if (c == '\n') S->s.line--;
	if (S->s.s[S->s.i] != c) sml_error("sunread: previously read different char");
    }
    else if (S->f.t == ASTRM) {
	if (S->s.i <= 0) sml_error("sunread: no previous read");
	S->s.i--;
	if (c == '\n') S->a.line--;
	if (*(char *) aref(S->a.a, S->a.i) != c)
	  sml_error("sunread: previously read different char");
    }
    else sml_error("sunread: can't read from this kind of stream");
}    

void swrite (char c, union stream *S)
{
    if (S == NULL) ;
    if (S->f.t == FSTRM || S->f.t == PSTRM) {
	if (c != '\0') write_char(c, S->f.f);
    }
    else if (S->f.t == ASTRM) {
	apush(c, S->a.a);
    }
    else if (S->f.t == OSTRM) {
	toplevel_write((unsigned char) c);
    }
    else sml_error("swrite: can't write to this kind of stream");
}

void swrite_string (char *s, union stream *S)
{
    if (S != NULL) {
	while (*s) swrite(*s++, S);
    }
}

#define sunwrite(c,S) (sunwrite_if((c),(S)) ? 1 : sml_error("wrong char or bad stream in unwrite"))

int sunwrite_if (char c, union stream *S)
{
    char old;

    if (S == NULL) return 1;
    else if (S->f.t == ASTRM) {
	atop(old, S->a.a);
	if (old == c) {
	    apop(old, S->a.a);
	    return 1;
	}
	else return 0;
    }
    else return 0;
}


void scat (union stream *instream, union stream *outstream)
{
    char c;

    if (instream != NULL) {
	sunwrite_if('\0', outstream);
	while (c = sread(instream))
	  swrite(c, outstream);
	sclose(instream);
    }
}

char *sstring (union stream *S)
{
    if (S == NULL) return NULL;
    else if (S->f.t == SSTRM) {
	return S->s.s;
    }
    else if (S->f.t == ASTRM) {
	return (char *) S->a.a->contents;
    }
    else sml_error("sstring: can't coerce this kind of stream to a string");
}

char *SString (union stream *S)
{
    char *s;

    if (S == NULL) return "<null stream>";
    else if (S->f.t != SSTRM && S->f.t != ASTRM) return "<unprintable stream>";
    else {
	s = sstring(S);
	return s == NULL ? "<null string>" : s;
    }
}

union stream *sstream (char *s)
{
    struct sstrm *S;

    allocate(S, 1, struct sstrm);
    S->t = SSTRM;
    S->s = s == NULL ? NULL : strdup(s);
    return (union stream *) S;
}

union stream *cstream (char c)
{
    struct sstrm *S;

    allocate(S, 1, struct sstrm);
    S->t = SSTRM;
    allocate(S->s, 2, char);
    S->s[0] = c;
    S->s[1] = '\0';
    return (union stream *) S;
}

union stream *fstream (float f)
{
    char buf[64];

    sprintf(buf, "%f", f);
    return sstream(buf);
}

union stream *istream (int i)
{
    char buf[64];

    sprintf(buf, "%d", i);
    return sstream(buf);
}

int slen (union stream *S)
{
    if (S == NULL) return 0;
    else if (S->f.t == SSTRM) {
	return S->s.s == NULL ? 0 : strlen(S->s.s);
    }
    else if (S->f.t == ASTRM) {
	return alen(S->a.a)-1;
    }
    else sml_error("slen: can't get length of this kind of stream");
}

int snull (union stream *S)
{
    if (S == NULL) return 1;
    else if (speek(S)) return 0;
    else return 1;
}

int sreset (union stream *S)
{
    if (S->f.t == SSTRM) S->s.i = 0;
    else if (S->f.t == ASTRM) S->a.i = 0;
    else sml_error("Can't reset this type of stream");
}

char *sfilename (union stream *S)
{
    if (S != NULL) {
	switch (S->f.t) {
	  case FSTRM: case PSTRM:
	    return S->f.fname;
	  case SSTRM:
	    return S->s.fname;
	  case ASTRM:
	    return S->a.fname;
	}
    }
    return NULL;
}

int sline (union stream *S)
{
    if (S != NULL) {
	switch (S->f.t) {
	  case FSTRM: case PSTRM:
	    return S->f.line;
	  case SSTRM:
	    return S->s.line;
	  case ASTRM:
	    return S->a.line;
	}
    }
    return 0;
}
    

/* 
 * union stream *make_stream1 (int t, void *arg);
 * 
 * union stream *make_stream (t, arg)
 *     int t;
 *     void *arg;
 * {
 *     union stream *S = make_stream1(t, arg);
 *     indent(stdout);
 *     printf("Make Stream ");
 *     switch (t) {
 *       case FSTRM: printf("FSTRM"); break;
 *       case PSTRM: printf("PSTRM"); break;
 *       case ESTRM: printf("ESTRM"); break;
 *       case SSTRM: printf("SSTRM"); break;
 *       case ASTRM: printf("ASTRM"); break;
 *       default: printf("(other)"); break;
 *     }
 *     printf(" 0x%x\n", S);
 *     return S;
 * }
 */

union stream *make_stream (int t, void *arg)
{
    if (t == FSTRM || t == PSTRM) {
	struct fstrm *f;
	allocate(f, 1, struct fstrm);
	f->t = t;
	f->f = (FILE *) arg;
	f->line = 1;
	return (union stream *) f;
    }
    else if (t == ESTRM) {
	struct estrm *e;
	allocate(e, 1, struct estrm);
	e->t = t;
	e->in = (union stream *) arg;
	e->buf = NULL;
	return (union stream *) e;
    }
    else if (t == SSTRM) {
	struct sstrm *s;
	allocate(s, 1, struct sstrm);
	s->t = t;
	allocate(s->s, (int) arg, char);
	return (union stream *) s;
    }
    else if (t == ASTRM) {
	struct astrm *a;
	allocate(a, 1, struct astrm);
	a->t = t;
	a->a = make_aarray((int) arg, sizeof(char));
	return (union stream *) a;
    }
    else sml_error("make_stream: can't make this kind of stream");
}

void sclose (union stream *S)
{
    if (S == NULL) ;
    else if (S->f.t == OSTRM) ;
    else {
	if (S->f.t == FSTRM) {
	    fclose(S->f.f);
	    if (S == Instream) pop_instream();
	}
	else if (S->f.t == ESTRM) {
	    if (S->e.buf) sclose(S->e.buf);
	    sclose(S->e.in);
	}
	else if (S->f.t == PSTRM) {
	    pclose(S->f.f);
	}
	else if (S->f.t == SSTRM) {
	    if (S->s.s != NULL) free(S->s.s);
	}
	else if (S->f.t == ASTRM) {
	    free_aarray(S->a.a);
	}	
	else if (S->f.t == ARRAYSTRM) {
	    char **a = S->x.p;
	    while (*a != NULL) free(*a++);
	    free(S->x.p);
	}
	else sml_error("sclose: bad stream");
	free(S);
    }
}

/*
 *smark (union stream *S)
 *{
 *    if (S != NULL && S->f.t == FSTRM && S->f.fname != NULL) {
 *	S->f.fpos = ftell(S->f.f);
 *    }
 *}
 */

/**===================================================================
***
***			  TOPLEVEL STRUCTURE
***
***  The central function is sml_filter().  It takes two streams, an
***  instream and an outstream.  Characters or forms are read from the instream
***  and written to the outstream, until EOF is encountered on the instream.
***  
***  The main() function takes a list of filenames and formats.  The outer loop
***  goes through the formats (if none are specified, the format "plain" is used)
***  and calls main_do_format() on each.  The function main_do_format() clears
***  all program state.  Then it does toplevel processing on the file defining
***  the given format, then on each file specified on the command line.
***  
***  Toplevel processing is performed by sml_toplevel_filter().  It opens the
***  named file and associates it with stream, makes a note of the fact that the
***  stream is associated with an input file for debugging purposes, and calls
***  sml_filter() on it, directing the output to the Outstream.
***  
***  The Outstream is a unique stream of type OSTREAM.  All output is passed
***  through it.  It handles whitespace conventions, file inclusion, output
***  redirection, and special characters; it directs the result to the correct
***  output file.  The handler that does these things is the function 
***  toplevel_write(), which is called only when a character is written to the
***  Outstream.
***  
***  The function toplevel_write() is the only caller of include_file().  The
***  functions main_do_format() and include_file() are the only callers of
***  sml_toplevel_filter().  A file is included in response to a file-inclusion
***  control character (generated by the function sml_include_file()).  The
***  included file is passed to the Outstream in its entirety before any more
***  characters from the previous input file are passed to the Outstream.
***  
***  There is a stack of output files.  It is manipulated only by toplevel_write()
***  in response to output control characters.  toplevel_write() always directs
***  its output to the topmost output file on the stack.  Associated with each
***  output file is state information needed to decide what to do with whitespace
***  characters being directed to it.
***  
***  Whitespace interpretation is also controlled in part by the scanmode.
***  There is a stack for scanmodes, independent of the stack of output files.
***  The rules for whitespace interpretation are as follows:
***  
***      Whitespace characters (space, tab, and newline) are collected in
***      a buffer in the output file.  Whitespace appears on the output file
***      only when the buffer is flushed.
***  
***      Whitespace is flushed just before printing a non-whitespace, non-control
***      character.
**/


/**-------------------------------------------------------------------
***
***		      Output control characters
**/

#define CNULL         '\000'

#define CNORMAL       '\001'
#define CBREAKS       '\002'
#define CPARS         '\003'
#define CDELETE       '\004'
#define CPOPMODE      '\005'

#define CNOBR         '\010'  /* backspace */
#define CTAB          '\011'  /* horizontal tab */
#define CNL           '\012'  /* newline */
#define CVS           '\013'  /* vertical tab */
#define CPAR          '\014'  /* new page */
#define CBR           '\015'  /* carriage return */
#define CNOVS         '\016'
#define CFRBR         '\020'
#define CNOSP         '\021'
#define CFRPAR        '\022'
#define CINDENT       '\030'
#define CUNDENT       '\031'

#define CPUSHFILE     '\023'
#define CPOPFILE      '\024'
#define CINCLUDE      '\025'

#define CESC          '\033'

#define isctrl(c) ((c) < '\040' || (c) > '\176')


/**-------------------------------------------------------------------
***
***			      Scan Modes
**/

char ScanModeStack[STACKSIZE];
int Sd = 0;

#define NORMAL_WS   CNORMAL
#define INS_BREAKS  CBREAKS
#define INS_PARS    CPARS
#define DELETE_WS   CDELETE

#define push_scan_mode(mode) \
  (Sd >= STACKSIZE ? sml_error("ScanMode overflow") : (ScanModeStack[Sd++] = (mode)))

#define pop_scan_mode() \
  (Sd > 0 ? Sd-- : sml_error("pop_scan_mode: empty stack"))

#define ScanMode (Sd > 0 ? ScanModeStack[Sd-1] : 1)

char parse_scan_mode (char *m)
{
    if (string_equal(m, "normal")) return NORMAL_WS;
    else if (string_equal(m, "breaks")) return INS_BREAKS;
    else if (string_equal(m, "pars")) return INS_PARS;
    else if (string_equal(m, "delete")) return DELETE_WS;
    else sml_error("parse_scan_mode: unrecognized mode \"%s\"", m);
}


/**-------------------------------------------------------------------
***
***			    Instream Stack
**/

int sml_error (char *fmt, ...)
{
    va_list args;
    fmt = va_arg(args, char*);

    FILE *file = NoRedirect ? stdout : stderr;
  
    va_start(args,fmt);
    fprintf(file, "**ERROR  ");
    if (Instream == NULL) fprintf(file, "with NULL instream");
    else if (Instream->f.t != FSTRM || Instream->f.fname == NULL) {
	fprintf(file, "with non-file instream");
    }
    else {
	fprintf(file, "%s line %d", Instream->f.fname, Instream->f.line);
    }
    fprintf(file, ": ");
    vfprintf(file, fmt, args);
    terpri(file);
    va_end(args);
  
    fflush(file);
    if (debug_on_error)
      abort();
    else
      exit(1);
}


/**-------------------------------------------------------------------
***
***			    Outfile stack
***			    Outfile state
**/

unsigned char Waiting;

struct outfile {
    FILE *file;
    unsigned char ws_state;
};

struct outfile OutfileStack[FSTACKSIZE];
int Od = 0;

#define OutfileData  (OutfileStack[Od-1])
#define Outfile      (OutfileData.file)
#define WsState      (OutfileData.ws_state)

#define FSP      1   /* space or tab encountered */
#define FBR      2   /* newline or break encountered */
#define FVS      4   /* vspace encountered */
#define FNOVS    8   /* vspace supprressed */
#define FNOBR   16   /* break & vspace suppressed */
#define FNOSP   32   /* space & break & vspace suppressed */
#define FEOF    64   /* at eof (break oblig, space & vspace suppressed) */

#define is_eof       (GET(WsState,FEOF))
#define is_sp        (GET(WsState,FSP))
#define is_br        (GET(WsState,FBR))
#define is_vs        (GET(WsState,FVS))
#define is_novs      (GET(WsState,FNOVS))
#define is_nobr      (GET(WsState,FNOBR))
#define is_nosp      (GET(WsState,FNOSP))

#define clear_ws()   (WsState = 0)
#define set_sp()     (SET(WsState,FSP))
#define set_br()     (SET(WsState,FBR))
#define set_vs()     (SET(WsState,FVS))
#define set_novs()   (SET(WsState,FNOVS))
#define set_nobr()   (SET(WsState,FNOBR))
#define set_nosp()   (SET(WsState,FNOSP))
#define at_bof()     (clear_ws(), set_nosp())
#define at_eof()     (SET(WsState,FEOF))

#define WPUSH     1   /* reading filename for push */
#define WESC      2   /* reading escaped character */

char WFilename[MAXFILENAME];
int WFi = 0;

int IndentUnit = 2;

char *Cookies[255];
int Cd = 0;

unsigned char get_cookie (char *s)
{
    if (Cd >= 255) sml_error("get_cookie: stack overflow");
    Cookies[Cd++] = strdup(s);
    return (unsigned char) Cd;
}

#define cookie_string(c) (Cookies[c-1])

void free_cookie (unsigned char c)
{
    free(Cookies[c-1]);
    Cookies[c-1] = NULL;
    while (Cd > 0 && Cookies[Cd-1] == NULL) Cd--;
}

char *Escapes[256] = {NULL};
int AutoEscape = 128;
int TWState = 0;

int toplevel_write (unsigned char c)
{
    char *s;
    
    if (Od < 1) sml_error("toplevel_write: no Outfile");
    else if (Raw) {
	sml_print_char(c, &TWState, stdout);
    }
    else if (Waiting == WPUSH) {
	if (isspace(c)) {
	    Waiting = 0;
	    WFilename[WFi] = 0;
	    push_outfile(WFilename);
	}
	else {
	    WFilename[WFi++] = c;
	}
    }
    else if (Waiting == WESC) {
	Waiting = 0;
	if (Escapes[c] == NULL) sml_error("Undefined escape %d", c);
	write_special_string(Escapes[c]);
    }
    else if (Specials[c] != NULL) {
	flush_ws();
	write_special_string(Specials[c]);
    }
    else if (c == '\0') ;
    else if (c == CPAR) sml_error("Encountered CPAR");
    else if (c == CBR) sml_error("Encountered CBR");
    else if (c == CINDENT) sml_error("Encountered CINDENT");
    else if (c == CUNDENT) sml_error("Encountered CUNDENT");
    else if (c == CPUSHFILE) Waiting = WPUSH, WFi = 0;
    else if (c == CPOPFILE) pop_outfile();
    else if (c == CINCLUDE) sml_error("Encountered CINCLUDE");
    else if (c == CESC) flush_ws(), Waiting = WESC;
    else if (c == ' ') set_sp();
    else if (c == '\t') set_sp();
    else if (c == '\n') set_br();
    else if (c == CFRBR) sml_error("Encountered CFRBR");
    else if (c == CFRPAR) sml_error("Encountered CFRPAR");
    else if (c == CVS) set_vs();
    else if (c == CNOVS) set_novs();
    else if (c == CNOBR) set_nobr();
    else if (c == CNOSP) set_nosp();
    else if (c > CNULL && c < CPOPMODE) push_scan_mode(c);
    else if (c == CPOPMODE) pop_scan_mode();
    else flush_ws(), print_char(c, Outfile);
}

void toplevel_close ()
{
    while (Od > 0) pop_outfile();
}

void write_special_string (unsigned char *s)
{
    unsigned char c;

    while (c = *s++) {
	if (c == CESC) {
	    c = *s++;
	    if (Escapes[c] == NULL) sml_error("Undefined escape %d", c);
	    write_special_string(Escapes[c]);
	}
	else if (c == ' ' || c == '\t' || c == '\n') {
	    print_char(c, Outfile);
	}
	else if (isctrl(c)) {
	    sml_error("Illegal control character '%c' in special string", c);
	}
	else print_char(c, Outfile);
    }
}

void flush_ws ()
{
    int i;
    
    if (is_eof) {
	terpri(Outfile);
    }
    else if (is_vs && !(is_novs || is_nobr || is_nosp)) {
	fprintf(Outfile, "\n\n");
    }
    else if (is_br && !(is_nobr || is_nosp)) {
	terpri(Outfile);
    }
    else if (is_sp && !is_nosp) {
	print_char(' ', Outfile);
    }
    clear_ws();
}

void push_outfile (char *filename)
{
    FILE *file;
    char *mode = "w";

    if (Od >= FSTACKSIZE) sml_error("push_outfile: OutfileStack overflow");

    if (*filename == '>') {
	if (*++filename == '>') filename++, mode = "a";
    }
    if (NoRedirect) {
	file = stdout;
	printf("^<file %s>", filename);
    }
    else file = (*filename == 0) ? stdout : fopen(filename, mode);
    if (file == NULL) sml_error("unable to open %s", filename);
    Od++;
    Outfile = file;
    at_bof();
}
    
void pop_outfile ()
{
    if (Od <= 0) sml_error("pop_file: empty stack");
    at_eof();
    flush_ws();
    if (NoRedirect) printf("^</file>");
    else {
 	if (Outfile != stdout && Outfile != stderr) fclose(Outfile);
    }
    Od--;
}

/*
 * #define NINCFILES 16
 * 
 * char *IncFiles[NINCFILES];
 * char IncRaw[NINCFILES/8];
 * 
 * unsigned char sml_include (char *filename, int raw)
 * {
 *     int i;
 * 
 *     for (i = 0; i < NINCFILES; i++) {
 * 	if (IncFiles[i] == NULL) break;
 *     }
 *     if (i >= NINCFILES) sml_error("sml_include: out of slots for include files");
 *     IncFiles[i] = strdup(filename);
 *     if (raw) setbit(IncRaw, i);
 *     else unsetbit(IncRaw, i);
 *     return (unsigned char) (i + 1);
 * }
 *
 * 
 * include_file (unsigned char c)
 * {
 *     int i = c-1, raw;
 *     char *filename, buffer[MAXFILENAME];
 * 
 *     strcpy(buffer, IncFiles[i]);
 *     filename = find_filename(buffer, SmlPath);
 *     if (filename == NULL) {
 * 	addsuf(buffer, ".sml");
 * 	filename = find_filename(buffer, SmlPath);
 * 	if (filename == NULL) sml_error("Include file not found: %s", buffer);
 *     }
 *     if (getbit(IncRaw, i)) {
 * 	FILE *file = Fopen(filename, "r");
 * 	scat(make_stream(FSTRM, file), Outstream);
 *     }
 *     else sml_toplevel_filter(filename);
 *     free(IncFiles[i]);
 *     IncFiles[i] = NULL;
 * }
 */


/**===================================================================
***
***			   Toplevel Filter
**/


/*
 *int prefetch1 (struct estrm *S);
 *
 *int prefetch (struct estrm *S)
 *{
 *    indent(stdout);
 *    printf("Enter prefetch 0x%x\n", S);
 *    push_indent(2);
 *
 *    prefetch1(S);
 *
 *    pop_indent();
 *    indent(stdout);
 *    printf("Exit prefetch.  buf = 0x%x, la = %c\n", S->buf, S->la);
 *}
 */

int prefetch (struct estrm *S)
{
    char c;
    
    if (S->la) return 1;
    while (1) {
	if (S->buf != NULL) {
	    c = sread(S->buf);
	    if (c) break;
	    else {
		sclose(S->buf);
		S->buf = NULL;
	    }
	}
	else {
	    c = sread(S->in);
	    if (c != Escape) break;
	    c = speek(S->in);
	    if (c == Escape) {
		sread(S->in);
		break;
	    }
	    else if (c == ' ' || c == '\t' || c == '\n') {
		sml_scan_comment(S->in);
	    }
	    else {
		S->buf = sml_eval(sml_scan_form(S->in));
	    }
	}
    }
    S->la = c;
    return 1;
}
	

union stream *sml_open (char *filename)
{
    char buffer[MAXFILENAME];
    union stream *stream;
    FILE *file;

    if (filename == NULL) {
	file = stdin;
    }
    else {
	strcpy(buffer, filename);
	filename = find_filename(buffer, SmlPath);
	if (filename == NULL) {
	    addsuf(buffer, ".sml");
	    filename = find_filename(buffer, SmlPath);
	    if (filename == NULL) sml_error("Include file not found: %s", buffer);
	}
	file = fopen(filename, "r");
	if (file == NULL) sml_error("unable to open %s", filename);
    }
    stream = make_stream(FSTRM, file);
    stream->f.fname = strdup(filename);
    push_instream(stream);
    return stream;
}


/* 
 * int sml_toplevel_filter (char *filename)
 * {
 *     char c;
 *     union stream *stream;
 *     
 *     stream = make_stream(FSTRM, Fopen(filename, "r"));
 *     stream->f.fname = filename;
 *     push_instream(stream);
 *     sml_filter(stream, Outstream);
 *     sclose(stream);
 *     pop_instream();
 * }
 *
 * 
 * sml_filter (union stream *instream, union stream *outstream)
 * {
 *     char c;
 *     
 *     while (c = sread(instream)) {
 * 	if (c == Escape) {
 * 	    c = speek(instream);
 * 	    if (c == Escape) {
 * 		sread(instream);
 * 		swrite(c, outstream);
 * 	    }
 * 	    else if (c == ' ' || c == '\t' || c == '\n') {
 * 		sml_scan_comment(instream);
 * 	    }
 * 	    else {
 * 		smark(instream);
 * 		scat(sml_eval(sml_scan_form(instream)), outstream);
 * 	    }
 * 	}
 * 	else swrite(c, outstream);
 *     }
 *     swrite('\0', outstream);
 * }
 */


int sml_filter (char *filename)
{
    scat(sml_expander(sml_open(filename)), Outstream);
}


/**===================================================================
***
***			       Scanning
**/

/**
***  Scans a term: one of:
***  - a single char
***  - a string in braces.  not expanded.
***  - an escaped string in braces.  expanded.
***
***  The returned stream is newly allocated, and will need
***  to be freed.
**/

union stream *sml_scan_term (union stream *instream)
{
    char c;
    int depth = 0, startline;
    union stream *outstream;

    while (1) {
	c = sread(instream);
	if (c == 0) sml_error("Missing argument for %s", form_fnc_string(CurrentlyScanning));
	else if (c == Left) break;
	else if (c == '^') {
	    c = speek(instream);
	    if (c == ' ' || c == '\t' || c == '\n') {
		do c = sread(instream);
		while (!(c == 0 || c == '\n'));
	    }
	    else sml_error("Missing argument for %s", form_fnc_string(CurrentlyScanning));
	}
    }

    outstream = make_stream(ASTRM, 80);
    startline = sline(instream);
    while (1) {
	c = sread(instream);
	if (c == Left) depth++;
	else if (c == Right) {
	    depth--;
	    if (depth < 0) {
		swrite('\0', outstream);
		break;
	    }
	}
	else if (c == '\0') {
	    sml_error("sml_scan_arg: premature EOF, term starting line %d", startline);
	}
	swrite(c, outstream);
    }

    return outstream;
}


union stream *sml_scan_term_tws (union stream *instream)
{
    union stream *outstream = sml_scan_term(instream);
    while (isspace(speek(instream))) {
	if (sread(instream) == '\n') break;
    }
    return outstream;
}


char *sml_scan_word (union stream *instream)
{
    static char buf[WORDMAX+1];
    char c;
    int first = 1, i = 0, quoted = 0;

    if (string_member(speek(instream), Prenectors)) {
	buf[i++] = sread(instream);
    }

    c = speek(instream);
    if (!isalnum(c) && !string_member(c, Connectors)) {
	buf[i++] = sread(instream);
    }
    else {
	while (c = sread(instream)) {
	    if (!isalnum(c) && !string_member(c, Connectors)) {
		if (c != Terminator) sunread(c, instream);
		break;
	    }
	    if (i >= WORDMAX) sml_error("sml_scan_symbol: buffer overflow");
	    buf[i++] = c;
	}
    }

    buf[i] = '\0';
    if (i == 0) sml_error("sml_scan_word: null word");
    return buf;
}


#define sml_scan_symbol(stream) (sml_intern(sml_scan_word(stream)))


void sml_scan_comment (union stream *instream)
{
    int c;

    while ((c = sread(instream)) != '\n' && c != '\v' && c != EOF) ;
    if (c == '\v') sunread(c, instream);
}


/**
***  Expands the instream, creating a new stream.  Then frees the instream.
**/

union stream *sml_expand (union stream *instream)
{
    char c;
    union stream *outstream;
 
    outstream = make_stream(ASTRM, 80);
    scat(sml_expander(instream), outstream);
    return outstream;
}
    

/*
 * union stream *sml_expand (union stream *instream)
 * {
 *     char c;
 *     union stream *outstream;
 * 
 *     outstream = make_stream(ASTRM, slen(instream));
 *     sml_filter(instream, outstream);
 *     sclose(instream);
 * 
 *     return outstream;
 * }
 */

char *sml_reduce (union stream *S)
{
    char *s;
    
    if (S->f.t == SSTRM) {
	s = S->s.s;
    }
    else if (S->f.t == ASTRM) {
	s = S->a.a->contents;
	free(S->a.a);
    }
    else if (S->f.t == ESTRM) {
	union stream *outstream;
	outstream = make_stream(ASTRM, 80);
	scat(S, outstream);
	sclose(S);
	return sml_reduce(outstream);
    }
    else if (S->f.t == ARRAYSTRM) {
	s = S->x.p;
    }
    else sml_error("sml_reduce: can't reduce this kind of stream");
    free(S);

    return s;
}


/**===================================================================
***
***		       Symbols and Definitions
***

***  Definitions and Environments
***
***  The parameter-list, mask, and value of a definition belong to the definition.
***  sml_set_definition() creates a parameter list and mask for the definition.
***  It does not consume the input parameter string, but it DOES consume the input
***  value, passing it on to the definition.
***
***  defun()           does NOT consume inputs; does modify def
***  defprimitive()    does NOT consume inputs; does modify def
***
***  bind_sym()            DOES consume value-string, but not other inputs
***
***  Global definitions are permanent.  They are created by sml_intern().
***
***  Lexical and dynamic definitions are part of a binding which is part of an
***  environment.  The bindings, including everything in the definitions, belongs
***  to the environment.  An environment is created by make_env(), filled by
***  calls to bind_sym(), pushed onto one of the stacks, and automatically destroyed
***  when it is popped from the stack.  (The actual destruction is done by
***  free_env().)
***
***  sml_eval() internally creates and destroys lexical environments.
***
***  make_env()        creates env
***  bind_sym()            modifies env, consumes value string
***  push_lexical()    does NOT modify env
***  pop_lexical()     destroys env, including its definitions
***
***  symbol_definition() finds a definition.  If the returned definition is
***  lexical or dynamic, it is good only as long as the environment it comes
***  from is on the stack.  Remember that the value in the definition belongs
***  to the definition (or to the environment that contains it).
***

***  Forms
***
***  A form contains a definition and an array of stream pointers (args).
***  The arg array itself belongs to the form, but the individual args are
***  expected to be consumed by the user of the form.  The definition does
***  NOT belong to the form, and is good only as long as the environment it
***  belongs to is good.
***
***  sml_scan_form() produces a form and passes ownership to the caller.
***  It is the caller's responsibility to consume the form's arguments
***  and dispose of the form.
***
***  free_form()       consumes a form, but not the arguments it contains
***
***  sml_eval()        consumes form, including args
***                    creates stream
***

***  Primitive Functions
***
***  A primitive function should NOT consume its arguments.  It should
***  produce a stream.
***
***  Note that if a primitive function modifies its arguments, it is modifying
***  the values of the lexical bindings of its parameters.
**/


#define global_definition(sym) ((struct definition *) aneed(GlobalDefs,(sym)-1))

#define defun(name,params,value) \
  (defun1((name), (params), strdup(value), REGULAR))

#define defprimitive(name,params,value) \
  (defun1((name), (params), (value), PRIMITIVE))

int defun1 (char *name, char *params, void *value, int prim)
{
    int sym = sml_intern(name);
    struct params p;

    parse_parameters(&p, params, prim);

    /** It is ESSENTIAL to call global_definition() AFTER parse_parameters **/
    sml_set_definition(global_definition(sym), &p, value);
}

/** N.B.!  This function does NOT expand the value, but the sml command defvar does! **/
int defvar (char *name, char *value)
{
    struct definition *def;

    def = global_definition(sml_intern(name));
    if (!is_defined(def)) {
	sml_set_definition(def,
			   NULL,
			   value == NULL ? NULL : strdup(value));
    }
}


int sml_intern (char *s)
{
    int sym = pat_insert(s, SymbolTable)+1, d;
    struct definition *def;
    
    if (new_entry_p) {
	if (sym != alen(GlobalDefs)+1) {
	    sml_error("SymbolTable and GlobalDefs out of synch");
	}
	def = apull(GlobalDefs);
	def->n = -1;
	def->value = NULL;
    }

    return sym;
}


/**  WARNING WARNING WARNING - do not call symbol_definition() to get a  **/
/**  def until AFTER you have parsed the parameters.  parse_parameters() **/
/**  calls sml_intern(), which can cause GlobalDefs to resize, invalidating  **/
/**  any extant pointers to global defs.                                 **/

int parse_parameters (struct params *p, char *params, int prim)
{
    char c, *s, buf[128];
    int i;

    p->n = 0;
    p->pa = NULL;
    if (params != NULL && (*params == '\0' || string_equal(params, "."))) {
	p->mask = make_bit_array(1);
	if (prim) setbit(p->mask, 0);
    }
    else if (params != NULL) {
	if (strlen(params) > 127) sml_error("parse_parameters: buffer overflow");
	strcpy(buf, params);
	params = buf;
	p->n = 1;
	for (s = params; *s; s++) {
	    if (*s == ',') p->n++;
	}
	allocate(p->pa, p->n, int);
	p->mask = make_bit_array(p->n+1);
	if (prim) setbit(p->mask, p->n);

	for (i = 0; i < p->n; i++) {
	    if (i > 0) {
		if (*params == ',') params++;
		else sml_error("ill-formed parameter list");
	    }
	    while (isspace(*params)) params++;
	    if (*params == '-') params++;
	    else {
		if (*params == '+') params++;
		setbit(p->mask, i);
	    }
	    while (isspace(*params)) params++;
	    s = params;
	    while (!(isspace(*params) || *params == ',' || *params == '\0'))
	      params++;
	    c = *params;
	    *params = '\0';
	    p->pa[i] = *s ? sml_intern(s) : 0;
	    *params = c;
	    while (isspace(*params)) params++;
	}
	while (isspace(*params)) params++;
	if (*params != '\0') sml_error("Ill-formed parameter list");
    }
}

int sml_set_definition (struct definition *def, struct params *params, char *value)
{
    if (def->pa != NULL) free(def->pa);
    if (def->mask != NULL) free(def->mask);
    if (def->value != NULL) free(def->value);

    if (params == NULL) {
	def->n = 0;
	def->pa = NULL;
	def->mask = NULL;
	def->value = value;
    }
    else {
	def->n = params->n;
	def->pa = params->pa;
	def->mask = params->mask;
	def->value = value;
    }
    return 1;
}


/**===================================================================
***
***				Forms
**/

#define form_length(form) ((form)->def->n)

char *form_fnc_string (struct form *form)
{
    return form == NULL ? "<no fnc>" : symbol_name(form->sym);
}

struct form *make_form (int symbol)
{
    struct definition *def = symbol_definition(symbol);
    struct form *form;

    allocate(form, 1, struct form);
    form->sym = symbol;
    form->def = def;
    if (def->n > 0) {
	allocate(form->args, def->n, union stream *);
    }
    return form;
}

void sml_print_form (struct form *form, int width, FILE *file)
{
    char *s;
    int i, j;
    
    s = symbol_name(form->sym);
    print_string(s, file);
    width -= strlen(s);
    if (form->def->n > 0) {
	width /= form->def->n;
	if (width < 0) width = 0;
	for (i = 0; i < form->def->n; i++) {
	    sml_print_stream(form->args[i], width, file);
	}
    }
}

int sml_print_stream (union stream *S, int width, FILE *file)
{
    if (S == NULL) print_string("<nullstream>", file);
    else if (S->f.t == FSTRM) print_string("<file>", file);
    else if (S->f.t == ESTRM) print_string("<expansion>", file);
    else if (S->f.t == PSTRM) print_string("<pipe>", file);
    else if (S->f.t == OSTRM) print_string("<outfile>", file);
    else if (S->f.t == XSTRM) print_string("<obj>", file);
    else if (S->f.t == ARRAYSTRM) print_string("<array>", file);
    else if (S->f.t != SSTRM && S->f.t != ASTRM) print_string("<bad>", file);
    else sml_print_string (S->f.t == SSTRM ? S->s.s : S->a.a->contents, width, file);
}

int sml_print_string (char *s, int width, FILE *file)
{
    int state = 0;

    if (s == NULL) print_string("<null>", file);
    else {
	print_char(Left, file);
	width -= 2;
	while (*s) {
	    if (width <= 0) {
		print_string("...", file);
		break;
	    }
	    width -= sml_print_char(*s++, &state, file);
	}
	print_char(Right, file);
    }
}

int sml_print_char (unsigned char c, int *statep, FILE *file)
{
    if (GET(*statep, PC_WESC)) {
	UNSET(*statep, PC_WESC);
	fprintf(file, "%d>", c);
	return 2;
    }
    else {
	switch (c) {
	  case CNULL: print_string("^<NULL>", file); return 7;
	  case CNORMAL: print_string("^<NormalMode>", file); return 13;
	  case CBREAKS: print_string("^<BreaksMode>", file); return 13;
	  case CPARS: print_string("^<ParsMode>", file); return 11;
	  case CDELETE: print_string("^<DelMode>", file); return 10;
	  case CPOPMODE: print_string("^<PopMode>", file); return 10;
	  case CTAB: print_string("^<tab>", file); return 6;
	  case CNL:
	    if (GET(*statep, PC_NEWLINES)) {
		print_char(c, file); return 1;
	    }
	    else {
		print_string("^<nl>", file); return 5;
	    }
	  case CVS: print_string("^<vs>", file); return 5;
	  case CPAR: print_string("^<par>", file); return 6;
	  case CBR: print_string("^<br>", file); return 5;
	  case CFRBR: print_string("^<freshbr>", file); return 10;
	  case CNOSP: print_string("^<nosp>", file); return 7;
	  case CFRPAR: print_string("^<freshpar>", file); return 11;
	  case CINDENT: print_string("^<indent>", file); return 9;
	  case CUNDENT: print_string("^<undent>", file); return 9;
	  case CPUSHFILE: print_string("^<file>", file); return 7;
	  case CPOPFILE: print_string("^</file>", file); return 11;
	  case CINCLUDE: print_string("^<include>", file); return 10;
	  case CESC: print_string("^<esc ", file); SET(*statep,PC_WESC); return 6;
	  default:
	    if (GET(*statep, PC_SPECIALS) && c < 128 && Specials[c] != NULL) {
		fprintf(file, "^<special %c>", c);
		return 12;
	    }
	    else if (isctrl(c)) {
		fprintf(file, "^<ctl-%03o>", c);
		return 10;
	    }
	    else {
		print_char(c, file);
		return 1;
	    }
	}
    }
}


#define free_form(form) (TmpSMLform = (form), free(TmpSMLform->args), free(TmpSMLform))

struct form *sml_scan_form (union stream *stream)
{
    int i;
    struct form *form, *prev = CurrentlyScanning;

/*    smark(stream); */

    form = make_form(sml_scan_symbol(stream));
    CurrentlyScanning = form;

    for (i = 0; i < form_length(form); i++) {
	form->args[i] = sml_scan_term(stream);
    }
    CurrentlyScanning = prev;
    return form;
}


/**===================================================================
***
***			     Environments
**/

struct binding *LexicalStack[STACKSIZE];
int Ld = 0;

struct binding *DynamicStack[STACKSIZE];
int Dd = 0;
int Continuable = 0;

#define push_lexical(b) \
  (Ld > STACKSIZE ? sml_error("Lexical stack overflow") : (int)(LexicalStack[Ld++] = (b)))

#define push_dynamic(b) \
  (Dd > STACKSIZE ? sml_error("Dynamic stack overflow") : (int)(DynamicStack[Dd++] = (b)))

#define pop_lexical() (Ld > 0 ? free_env(LexicalStack[--Ld]) : 0)

#define pop_dynamic() (Dd > 0 ? free_env(DynamicStack[--Dd]) : 0)

#define LexEnv (Ld > 0 ? LexicalStack[Ld-1] : NULL)

#define DynEnv (Dd > 0 ? DynamicStack[Dd-1] : NULL)

struct definition *lexical_definition (int sym)
{
    int i;
    struct definition *def;
    
    for (i = Ld-1; i >= 0; i--) {
	def = env_definition(sym, LexicalStack[i]);
	if (def != NULL) return def;
	if (!Continuable) return NULL;
    }
    return NULL;
}

struct definition *dynamic_definition (int sym)
{
    int i;
    struct definition *def;

    for (i = 0; i < Dd; i++) {
	def = env_definition(sym, DynamicStack[Dd-1]);
	if (def != NULL) return def;
    }
    return NULL;
}

#define make_env(env,n) (allocate(env,(n)+1,struct binding))

int bind_sym (struct binding *b, int sym, char *params, char *value)
{
    b->sym = sym;

    if (params != NULL) {
	struct params p;
	parse_parameters(&p, params, REGULAR);
	sml_set_definition(&b->d, &p, value);
    }
    else sml_set_definition(&b->d, NULL, value);
}

int free_env (struct binding *env)
{
    struct binding *b;

    for (b = env; b->sym > 0; b++) {
	if (b->d.value != NULL) free(b->d.value);
	if (b->d.n > 0) {
	    free(b->d.pa);
	    free(b->d.mask);
	}
    }
    free(env);
}
    
struct definition *env_definition (int sym, struct binding *env)
{
    for (; env->sym > 0; env++) {
	if (env->sym == sym) return &env->d;
    }
    Continuable = env->sym;
    return NULL;
}
    
struct definition *symbol_definition (int sym)
{
    struct definition *def;

    if ((def = lexical_definition(sym)) != NULL) return def;
    else if ((def = dynamic_definition(sym)) != NULL) return def;
    else return global_definition(sym);
}


/**===================================================================
***
***			    Eval
**/

/** This consumes the form.
**/

union stream *sml_eval (struct form *form)
{
    struct definition *def = form->def;
    union stream *S, **args = form->args;
    struct binding *env = NULL;
    int sym, i, n = def->n;
    
    if (Trace) {
	indent(stdout);
	print_string("Evaluating form ", stdout);
	sml_print_form(form, 100, stdout);
	terpri(stdout);
	push_indent(2);
    }

    if (!is_defined(def)) {
	sml_error("Undefined directive %s", symbol_name(form->sym));
    }

    if (!is_function(def)) {
	if (args != NULL) sml_error("sml_eval: variable with args");
	S = sstream(def->value);
    }	

    else if (is_primitive(def)) {
	char **argv = NULL;
	if (n > 0) {
	    allocate(argv, n, char *);
	    for (i = 0; i < n; i++) {
		argv[i] = (getbit(def->mask, i) ?
			   sml_reduce(sml_expand(args[i])) :
			   sml_reduce(args[i]));
	    }
	}	
	S = ((primfnc*)def->value)(n, argv);
	if (n > 0) free(argv);
    }

    else {
	if (n > 0) {
	    make_env(env, n);
	    for (i = 0; i < n; i++) {
		sym = def->pa[i];
		bind_sym(&env[i], sym, NULL,
		     getbit(def->mask, i) ?
		     sml_reduce(sml_expand(args[i])) :
		     sml_reduce(args[i]));
		if (Trace) {
		    indent(stdout);
		    fprintf(stdout, "L-binding %s to \"", symbol_name(sym));
		    sml_print_string(env[i].d.value, 80, stdout);
		    print_char('"', stdout);
		    terpri(stdout);
		}
	    }
	    push_lexical(env);
	}
	S = def->value == NULL ? NULL : sml_expand(sstream(def->value));
	if (n > 0) pop_lexical();
    }

    if (Trace) {
	char *value;
	pop_indent();
	indent(stdout);
	print_string("Return ", stdout);
	sml_print_stream(S, 80, stdout);
	terpri(stdout);
    }

    return S;
}


int sml_print_env (struct binding *env, FILE *file)
{
    int first = 1;

    indent(file);
    fprintf(file, "<env *%x>\n", env);
    push_indent(2);
    for (; env->sym > 0; env++) {
	indent(file);
	fprintf(file, "%s -> <def *%x> \"%s\"\n",
		symbol_name(env->sym),
		&env->d,
		env->d.value == NULL ? "<null>" : env->d.value);
    }
    pop_indent();
    indent(file);
    fprintf(file, "</env>\n");
}

int sml_print_environment (FILE *file)
{
    int i;
    struct definition *def;

    if (Ld > 0) {
	indent(file);
	fprintf(file, "Lexical Environment:\n");
	push_indent(2);
	sml_print_env(LexicalStack[0], file);
	pop_indent();
    }

    if (GlobalDefs->len > 0) {
	indent(file);
	fprintf(file, "Global Environment:\n");
	push_indent(2);
	for (i = 0; i < GlobalDefs->len; i++) {
	    def = aref(GlobalDefs, i);
	    indent(file);
	    fprintf(file, "%s %s\n", symbol_name(i+1), def->value);
	}
	pop_indent();
    }
}


/**===================================================================
***
***			 Primitive Functions
**/

union stream *pf_defun (int n, char *argv[])
{
    if (n != 3) sml_error("defun takes three arguments");

    defun(argv[0], argv[1], argv[2]);

    return NULL;
}


union stream *pf_defvar (int n, char *argv[])
{
    if (n != 2) sml_error("defvar takes two arguments");

    defvar(argv[0], argv[1]);

    return NULL;
}


union stream *pf_envvar (int n, char *argv[])
{
    if (n != 1) sml_error("envvar takes one argument");

    defvar(argv[0], getenv(argv[0]));

    return NULL;
}


#define sml_set(s, v) (sml_setx((s), strdup(v)))

int sml_setx (char *s, void *v)
{
    int sym = sml_intern(s);
    struct definition *def = symbol_definition(sym);
    if (def->value) free(def->value);

    def->n = 0;
    if (def->mask != NULL) free(def->mask), def->mask = NULL;
    def->value = v;
}

void *sml_symbol_value (char *s)
{
    struct definition *def = symbol_definition(sml_intern(s));
    return def->value;
}


union stream *pf_set (int n, char *argv[])
{
    char *a[64], *value;
    int i;
    
    if (n != 2) sml_error("set takes two arguments");
    sml_set(argv[0], argv[1]);
    return NULL;
}


union stream *pf_setfun (int n, char *argv[])
{
    int sym;
    struct definition *def;
    struct params p;
    
    if (n != 3) sml_error("setfun takes three arguments");

    sym = sml_intern(argv[0]);
    parse_parameters(&p, argv[1], REGULAR);
    def = symbol_definition(sym);  /* this must FOLLOW parse_params() */
    sml_set_definition(def, &p, strdup(argv[2]));

    return NULL;
}


union stream *pf_upcase (int n, char *argv[])
{
    union stream *S;
    
    if (n != 1) sml_error("sml_upcase takes one argument");
    upcase_string(argv[0]);
    return sstream(argv[0]);
}


union stream *pf_showobj (int n, char *argv[])
{
    char *t, *x;

    if (n != 2) sml_error("sml_showobj takes two arguments");
    if (!Trace) sml_showobj(argv[0], argv[1]);
    return NULL;
}

int sml_showobj (char *t, char *x)
{
    if (string_equal(t, "def")) {
	int sym, i;
	struct definition *def;
	
	sym = sml_intern(x);

	if ((def = lexical_definition(sym)) != NULL) {
	    fprintf(stderr, "<ldef ");
	}
	else if ((def = dynamic_definition(sym)) != NULL) {
	    fprintf(stderr, "<ddef ");
	}
	else if ((def = global_definition(sym)) != NULL) {
	    fprintf(stderr, "<gdef %d/%d n=%d ", aid(GlobalDefs, def), GlobalDefs->len, def->n);
	}
	if (!is_defined(def)) fprintf(stderr, "undefined %s>", x);
	else if (!is_function(def)) {
	    fprintf(stderr, "var %s ", x);
	    sml_print_string(def->value, 80, stderr);
	    print_char('>', stderr);
	}
	else {
	    fprintf(stderr, "fnc %s ", x);
	    print_char('(', stderr);
	    for (i = 0; i < def->n; i++) {
		if (i != 0) print_char(',', stderr);
		print_char(getbit(def->mask, i) ? '+' : '-', stderr);
		if (def->pa[i]) print_string(symbol_name(def->pa[i]), stderr);
	    }
	    print_char(')', stderr);
	    print_char(' ', stderr);
	    if (is_primitive(def)) fprintf(stderr, "<c-fnc 0x%x>", def->value);
	    else sml_print_string(def->value, 80, stderr);
	    print_char('>', stderr);
	}
    }

    else fprintf(stderr, "<bad obj type %s>", t);
}
	

union stream *pf_message (int n, char *argv[])
{
    int i;
    FILE *file = NoRedirect ? stdout : stderr;

    if (NoRedirect) printf("^<msg>");
    for (i = 0; i < n; i++) {
	print_string(argv[i], file);
    }
    if (NoRedirect) printf("^</msg>");

    return NULL;
}


int sml_string_fields (char *s, char **a, int len)
{
    int n = 0, d = 0, delimited = 0;

    while (*s) {
	while (isspace(*s)) s++;
	if (*s == '\0') return n;
	if (n+1 > len) sml_error("sml_string_fields: array overflow");
	if (*s == Left) delimited = 1, d++, s++;
	a[n++] = s;
	for (; *s; s++) {
	    if (isspace(*s) && d == 0) break;
	    else if (*s == Left) d++;
	    else if (*s == Right) {
		d--;
		if (d < 0) sml_error("sml_string_fields: unbalanced parentheses");
		if (delimited && d==0) break;
	    }
	}
	*s++ = '\0';
    }
    return n;
}


/* we want a single allocation so that everything will work right with a single free() */

union stream *pf_array (int n, char *argv[])
{
    char *a[64], **b, *c, *stop;
    int i, len;
    
    if (n != 2) sml_error("pf_array takes two arguments");

    len = strlen(argv[1]) + 1;
    n = sml_string_fields(argv[1], a, 64);

    allocate(c, (n+1)*sizeof(char*) + len, char);
    b = (char **) c;
    c += (n+1)*sizeof(char*);
    stop = c + len;

    for (i = 0; i < n; i++) {
	len = strlen(a[i]) + 1;
	if (c + len > stop) sml_error("not enough space allocated in pf_array");
	strcpy(c, a[i]);
	b[i] = c;
	c += len;
    }
    b[n] = NULL;
    sml_setx(argv[0], b);
    
    return NULL;
}

union stream *pf_aref (int n, char *argv[])
{
    char **a;
    int i;
    
    if (n != 2) sml_error("pf_aref takes two arguments");

    a = sml_symbol_value(argv[0]);
    i = atoi(argv[1]);
    return sstream(a[i]);
}

union stream *pf_bind (int n, char *argv[])
{
    struct binding *env;

    if (n != 2) sml_error("pf_bind takes two arguments");

    make_env(env, 1);
    bind_sym(&env[0], sml_intern(argv[0]), NULL,
	 argv[1] == NULL ? NULL : strdup(argv[1]));
    push_dynamic(env);
    return NULL;
}

union stream *pf_bindf (int n, char *argv[])
{
    struct binding *env;

    if (n != 3) sml_error("pf_bindf takes three arguments");

    make_env(env, 1);
    bind_sym(&env[0], sml_intern(argv[0]), argv[1],
	 argv[2] == NULL ? NULL : strdup(argv[2]));
    push_dynamic(env);
    return NULL;
}
			  
union stream *pf_unbind (int n, char *argv[])
{
    if (n != 0) sml_error("unbind takes no arguments");
    pop_dynamic();
    return NULL;
}


union stream *pf_eval (int n, char *argv[])
{
    if (n != 1) sml_error("eval takes one argument");
    
    return sml_expand(sstream(argv[0]));
}


union stream *pf_scanmode (int n, char *argv[])
{
    if (n != 1) sml_error("scanmode takes one argument");
    return cstream(parse_scan_mode(argv[0]));
}


union stream *pf_pop_scanmode (int n, char *argv[])
{
    if (n != 0) sml_error("pf_pop_scanmode takes no arguments");
    return cstream(CPOPMODE);
}


union stream *pf_system (int n, char *argv[])
{
    if (n != 1) sml_error("pf_system takes one argument");

    return make_stream(PSTRM, popen(argv[0], "r"));
}


union stream *pf_date (int n, char *argv[])
{
    time_t t;
    char buf[128];
    
    if (n != 0) sml_error("pf_date takes no arguments");

    time(&t);
    strftime(buf, 128, "%X %x", localtime(&t));
    return sstream(buf);
}


union stream *pf_print_to (int n, char *argv[])
{
    FILE *file;

    if (n != 2) sml_error("pf_print_to takes two arguments");

    if (NoRedirect) {
	printf("^<print_to %s>%s</print_to>", argv[0], argv[1]);
    }
    else {
	file = fopen(argv[0], "w");
	if (file == NULL) sml_error("unable to open %s", argv[0]);
	print_string(argv[1], file);
	fclose(file);
    }
    return NULL;
}


union stream *pf_appendto (int n, char *argv[])
{
    char filename[MAXFILENAME+2];
    union stream *outstream;

    if (n != 2) sml_error("pf_appendto takes two arguments");

    filename[0] = '>';
    filename[1] = '>';
    strcpy(filename+2, argv[0]);

    outstream = make_stream(ASTRM, strlen(argv[1]+4));

    swrite(CPUSHFILE, outstream);
    swrite(get_cookie(filename), outstream);
    scat(sstream(argv[1]), outstream);
    swrite(CPOPFILE, outstream);
    return outstream;
}


int append_lexical (int nbindings, int *symbols, char **values)
{
    int i;
    struct binding *env;

    make_env(env, nbindings);
    env[nbindings].sym = -1;  /* makes it an append */
    for (i = 0; i < nbindings; i++) {
	bind_sym(&env[i], symbols[i], NULL, strdup(values[i]));
    }
    push_lexical(env);
}
    

union stream *pf_dolist (int n, char *argv[])
{
    char *buf[128], **a = buf;
    int i, sym;
    union stream *instream = NULL, *outstream;

    if (n != 2) sml_error("pf_dolist takes two arguments");
    n = sml_string_fields(argv[0], a, 128);
    if (n <= 0) sml_error("pf_dolist: no symbol to bind");
    sym = sml_intern(a[0]);
    n--; a++;
    outstream = make_stream(ASTRM, n*strlen(argv[1]));
    for (i = 0; i < n; i++) {
	append_lexical(1, &sym, &a[i]);
	scat(sml_expander(sstream(argv[1])), outstream);
	pop_lexical();
    }
    return outstream;
}

#define COLLECTMAX 20
static union stream *Collections[COLLECTMAX];
static int NCollections = -1;

union stream *pf_collecting (int n, char *argv[])
{
    if (n != 1) sml_error("pf_collecting takes one argument");
    if (++NCollections >= COLLECTMAX) sml_error("Out of collection stack space");
    Collections[NCollections] = make_stream(ASTRM, 128);
    scat(sml_expander(sstream(argv[0])), NULL);
    return Collections[NCollections--];
}

union stream *pf_collect (int n, char *argv[])
{
    if (n != 1) sml_error("pf_collect takes one argument");
    if (NCollections < 0) sml_error("pf_collect: not in context of pf_collecting");
    scat(sstream(argv[0]), Collections[NCollections]);
    return NULL;
}

union stream *pf_repeat (int n, char *argv[])
{
    int i;
    union stream *outstream;

    if (n != 2) sml_error("pf_repeat takes two arguments");
    n = atoi(argv[0]);
    outstream = make_stream(ASTRM, n*strlen(argv[1]));
    for (i = 0; i < n; i++) {
	scat(sstream(argv[1]), outstream);
    }
    return outstream;
}


union stream *pf_switch (int n, char *argv[])
{
    char *buf[128], **a = buf, *dflt = NULL;
    int i;
    union stream *instream = NULL, *outstream;

    if (n != 2) sml_error("pf_switch takes two arguments");
    n = sml_string_fields(argv[1], a, 128);
    if (n%2) dflt = a[--n];
    for (i = 0; i < n; i += 2) {
	if (string_equal(argv[0], a[i])) {
	    outstream = make_stream(ASTRM, 128);
	    scat(sml_expander(sstream(a[i+1])), outstream);
	    return outstream;
	}
    }
    if (dflt == NULL) return NULL;
    outstream = make_stream(ASTRM, 128);
    scat(sml_expander(sstream(dflt)), outstream);
    return outstream;
}

union stream *pf_file (int n, char *argv[])
{
    union stream *outstream;
    
    if (n != 1) sml_error("pf_file takes one argument");

    outstream = make_stream(ASTRM, 20);
    swrite(CPUSHFILE, outstream);
    swrite_string(argv[0], outstream);
    return outstream;
}
    
union stream *pf_unfile (int n, char *argv[])
{
    if (n != 0) sml_error("pf_unfile takes no arguments");
    return cstream(CPOPFILE);
}

union stream *pf_if (int n, char *argv[])
{
    union stream *cond, *outstream = NULL;

    if (n != 2) sml_error("pf_if takes two arguments");

    cond = sml_expand(sstream(argv[0]));
    if (!snull(cond)) outstream = sml_expand(sstream(argv[1]));
    sclose(cond);
    return outstream;
}

union stream *pf_ifelse (int n, char *argv[])
{
    union stream *cond, *outstream;
    
    if (n != 3) sml_error("pf_ifelse takes three arguments");

    cond = sml_expand(sstream(argv[0]));
    if (!snull(cond)) outstream = sml_expand(sstream(argv[1]));
    else outstream = sml_expand(sstream(argv[2]));
    sclose(cond);
    return outstream;
}

union stream *pf_unless (int n, char *argv[])
{
    union stream *cond, *outstream = NULL;
    
    if (n != 2) sml_error("pf_unless takes two arguments");

    cond = sml_expand(sstream(argv[0]));
    if (snull(cond)) outstream = sml_expand(sstream(argv[1]));
    sclose(cond);
    return outstream;
}

int defchar (char *command, char *value)
{
    int i;
    char s[3];

    i = AutoEscape++;
    if (i > 255) sml_error("defchar: out of auto-escape numbers");
    if (Escapes[i] != NULL) sml_error("defchar: auto-escape already used");
    Escapes[i] = strdup(value);
    s[0] = CESC;
    s[1] = (unsigned char) i;
    s[2] = 0;
    defvar(command, strdup(s));
}

union stream *pf_defchar (int n, char *argv[])
{
    if (n != 2) sml_error("pf_defchar takes two arguments");
    defchar(argv[0], argv[1]);
    return NULL;
}

union stream *pf_defspecial (int n, char *argv[])
{
    unsigned char c;
    if (n != 2) sml_error("pf_defspecial takes two arguments");

    /* First arg may be an escape-char sequence */
    if (argv[0][0] == CESC) {
	/* Make sure Escape code is present and not followed by extraneous characters. */
	if (!argv[0][1] || argv[0][2])
	  sml_error("first arg to defspecial must be a char");
	c = argv[0][1];
	if (Escapes[c] != NULL) free(Escapes[c]);
	Escapes[c] = strdup(argv[1]);
    }
    /* First arg is plain char */
    else {
	if (argv[0][0] == 0 || argv[0][1] != 0)
	  sml_error("first arg to defspecial must be char");
	c = argv[0][0];
	if (Specials[c] != NULL) free(Specials[c]);
	Specials[c] = strdup(argv[1]);
    }
    return NULL;
}


union stream *pf_escape (int n, char *argv[])
{
    char s[3];
    
    if (n != 1) sml_error("pf_escape takes one argument");
    n = atoi(argv[0]);
    if (n < 1 || n > 127) sml_error("pf_escape: escape number out of bounds");
    s[0] = CESC;
    s[1] = (unsigned char) n;
    s[2] = '\0';
    return sstream(s);
}

int atonum (struct number *num, char *s)
{
    if (s == NULL || s[0] == '\0') num->t = INTEGER, num->v.i = 0;
    else if (string_member('.', s)) num->t = FLOAT, num->v.f = atof(s);
    else num->t = INTEGER, num->v.i = atoi(s);
}
    
#define asfloat(num) ((num).t == INTEGER ? (float) (num).v.i : (num).v.f)
#define asint(num)   ((num).t == INTEGER ? (num).v.i : (int) (num).v.f)

union stream *pf_plus (int n, char *argv[])
{
    struct number x, y;

    if (n != 2) error("pf_plus takes two arguments");
    
    atonum(&x, argv[0]);
    atonum(&y, argv[1]);

    if (x.t == FLOAT || y.t == FLOAT) return fstream(asfloat(x) + asfloat(y));
    else return istream(asint(x) + asint(y));
}

union stream *pf_times (int n, char *argv[])
{
    struct number x, y;

    if (n != 2) error("pf_times takes two arguments");
    
    atonum(&x, argv[0]);
    atonum(&y, argv[1]);

    if (x.t == FLOAT || y.t == FLOAT) return fstream(asfloat(x) * asfloat(y));
    else return istream(asint(x) * asint(y));
}

union stream *pf_incr (int n, char *argv[])
{
    int sym, x = 0;
    struct definition *def;
    char buf[64];

    if (n != 1) error("pf_incr takes one argument");
    
    sym = sml_intern(argv[0]);
    def = symbol_definition(sym);
    if (def->value != NULL) {
	if (*def->value) x = atoi(def->value);
	free(def->value);
    }

    sprintf(buf, "%d", x+1);
    def->value = strdup(buf);
    return NULL;
}

union stream *pf_include (int n, char *argv[])
{
    char *filename = argv[0], buf[3];
    int raw = 0;

    if (n != 1) error("pf_include takes one argument");

    if (filename[0] == '#' && isspace(filename[1])) {
	raw = 1;
	filename++;
	while (isspace(*filename)) filename++;
    }
    if (raw) return sml_open(filename);
    else return sml_expand(sml_open(filename));
}


/* 
 * union stream *pf_include (int n, char *argv[])
 * {
 *     char *filename = argv[0], buf[3];
 *     int raw = 0;
 * 
 *     if (n != 1) error("pf_include takes one argument");
 * 
 *     if (filename[0] == '#' && isspace(filename[1])) {
 * 	raw = 1;
 * 	filename++;
 * 	while (isspace(*filename)) filename++;
 *     }
 *     buf[0] = CINCLUDE;
 *     buf[1] = sml_include(filename, raw);
 *     buf[2] = '\0';
 *     return sstream(buf);
 * }
 *
 * 
 * union stream *pf_style (int n, char *argv[])
 * {
 *     char filename[MAXFILENAME], s[3];
 * 
 *     if (n != 1) error("pf_style takes one argument");
 * 
 *     if (Format != NULL) sprintf(filename, "%s_%s.sml", Format, argv[0]);
 *     else sprintf(filename, "%s.sml", argv[0]);
 * 
 *     s[0] = CINCLUDE;
 *     s[1] = sml_include(filename, 0);
 *     s[2] = '\0';
 *     return sstream(s);
 * }
 */

union stream *pf_firstword (int n, char *argv[])
{
    char *s, *t;

    if (n != 1) error("pf_firstword takes one argument");
    s = argv[0];
    while (isspace(*s)) s++;
    t = s;
    while (*t && !isspace(*t)) t++;
    if (s == t) return NULL;
    *t = '\0';
    return sstream(s);
}

union stream *pf_restwords (int n, char *argv[])
{
    char *s;
    
    if (n != 1) error("pf_restwords takes one argument");
    s = argv[0];
    while (isspace(*s)) s++;
    while (*s && !isspace(*s)) s++;
    while (isspace(*s)) s++;
    return sstream(s);
}

union stream *pf_quote (int n, char *argv[])
{
    if (n != 1) error("pf_quote takes one argument");
    return sstream(argv[0]);
}

union stream *pf_kill (int n, char *argv[])
{
    if (n != 1) error("pf_kill takes one argument");
    return NULL;
}

union stream *pf_error (int n, char *argv[])
{
    if (n != 1) error("pf_error takes one argument");
    sml_error("%s", argv[0]);
    return NULL;
}

union stream *pf_equal (int n, char *argv[])
{
    if (n != 2) error("pf_equal takes two arguments");
    if (string_equal(argv[0], argv[1])) return sstream("1");
    else return NULL;
}

union stream *pf_value (int n, char *argv[])
{
    int sym;
    struct definition *def;

    if (n != 1) error("pf_value takes one argument");
    
    sym = sml_intern(argv[0]);
    def = symbol_definition(sym);
    return def->value == NULL ? NULL : sstream(def->value);
}

union stream *pf_Format (int n, char *argv[])
{
    return sstream(Format);
}

union stream *pf_mkdir (int n, char *argv[])
{
    char s[MAXFILENAME+10];
    if (n != 1) sml_error("mkdir takes 1 arg");
    if (NoRedirect) printf("^<mkdir %s>", argv[0]);
    sprintf(s, "mkdir -p %s", argv[0]);
    system(s);
    return NULL;
}

union stream *pf_file_exists_p (int n, char *argv[])
{
    if (n != 1) sml_error("file_exists_p takes 1 arg");
    return file_exists_p(argv[0]) ? sstream(argv[0]) : NULL;
}




/**===================================================================
***
***				 Main
**/


int sml_init ()
{
    int i;

    SymbolTable = make_dict(100);
    GlobalDefs = make_aarray(100, sizeof(struct definition));
    Od = 1;
    at_bof();
/*    for (i = 0; i < NINCFILES; i++) IncFiles[i] = NULL; */

    defprimitive("[bind", "+,+", &pf_bind);
    defprimitive("[bindf", "+,+,-", &pf_bindf);
    defprimitive("[file", "+", &pf_file);
    defprimitive("[scanmode", "+", &pf_scanmode);
    defprimitive("]bind", "", &pf_unbind);
    defprimitive("]bindf", "", &pf_unbind);
    defprimitive("]file", "", &pf_unfile);
    defprimitive("]scanmode", "", &pf_pop_scanmode);
    defprimitive("aref", "+,+", &pf_aref);
    defprimitive("appendto", "+,+", &pf_appendto);
    defprimitive("array", "+,+", &pf_array);
    defprimitive("collect", "+", &pf_collect);
    defprimitive("collecting", "-", &pf_collecting);
    defprimitive("date", "", &pf_date);
    defprimitive("defchar", "+,+", &pf_defchar);
    defprimitive("defspecial", "+,+", &pf_defspecial);
    defprimitive("defun", "+,+,-", &pf_defun);
    defprimitive("defvar", "+,+", &pf_defvar);
    defprimitive("dolist", "+,-", &pf_dolist);
    defprimitive("envvar", "+", &pf_envvar);
    defprimitive("equal", "+,+", &pf_equal);
    defprimitive("error", "+", &pf_error);
    defprimitive("escape", "+", &pf_escape);
    defprimitive("eval", "+", &pf_eval);
    defprimitive("file_exists_p", "+", &pf_file_exists_p);
    defprimitive("firstword", "+", &pf_firstword);
    defprimitive("Format", "", &pf_Format);
    defprimitive("if", "-,-", &pf_if);
    defprimitive("ifelse", "-,-,-", &pf_ifelse);
    defprimitive("include", "+", &pf_include);
    defprimitive("incr", "+", &pf_incr);
    defprimitive("kill", "+", &pf_kill);
    defprimitive("message", "+", &pf_message);
    defprimitive("mkdir", "+", &pf_mkdir);
    defprimitive("plus", "+,+", &pf_plus);
    defprimitive("print_to", "+,+", &pf_print_to);
    defprimitive("quote", "-", &pf_quote);
    defprimitive("repeat", "+,+", &pf_repeat);
    defprimitive("restwords", "+", &pf_restwords);
    defprimitive("set", "+,+", &pf_set);
    defprimitive("setfun", "+,+,-", &pf_setfun);
    defprimitive("showobj", "+,+", &pf_showobj);
    defprimitive("style", "+", &pf_include);
    defprimitive("switch", "+,-", &pf_switch);
    defprimitive("system", "+", &pf_system);
    defprimitive("times", "+,+", &pf_times);
    defprimitive("unless", "-,-", &pf_unless);
    defprimitive("upcase", "+", &pf_upcase);
    defprimitive("value", "+", &pf_value);


    /*  CTAB          '\011' */
    /*  CNL           '\012' */
    /*  CVS           '\013' */
    /*  CPAR          '\014' */
    /*  CBR           '\015' */
    /*  CNOBR         '\016' */
    /*  CFRBR         '\020' */
    /*  CNOSP         '\021' */
    /*  CFRPAR        '\022' */

    defvar("s", " ");
    defvar("t", "\t");
    defvar("n", "\n");
    defvar("v", "\013");
    defvar("novs", "\016");
    defvar("nobr", "\010");
    defvar("nosp", "\021");

    defun("[kill", "", "^[file{/dev/null}");
    defun("]kill", "", "^]file");

    defvar("dol", "$");
    defvar("caret", "^");
    defvar("lbrace", "{");
    defvar("rbrace", "}");
}


char *path_push (char *dir, char **pathp)
{
    char *s;

    allocate(s, strlen(dir) + strlen(*pathp) + 2, char);
    sprintf(s, "%s:%s", dir, *pathp);
    *pathp = s;
    return s;
}


int main (int argc, char *argv[])
{
    char buffer[MAXFILENAME], *filename;
    int i, didfile = 0;
    union stream *instream;
    FILE *file;
    
    defaults(SmlPath, "SMLPATH");
    parse_args(&argc, &argv, "*-bt-bs-br-bR",
	       &Trace, &Silent, &Raw, &NoRedirect);
    if (Trace) Raw = 1;
    if (Raw) {
	NoRedirect = 1;
	TWState = PC_NEWLINES | PC_SPECIALS;
    }
    sml_init();
    Outfile = stdout;

    for (i = 0; i < argc; i++) {
	if (argv[i][0] == '-') {
	    switch (argv[i][1]) {
	      case 'D':
		putenv(argv[i]+2);
		break;
	      case 'I':
		path_push(argv[i]+2, &SmlPath);
		break;
	      case 'F':
		Format = argv[i]+2;
		break;
	      default:
		error("Unrecognized flag %s", argv[i]);
	    }
	}
	else {
	    sml_filter(argv[i]);
	    didfile = 1;
	}
    }
    if (didfile == 0) {
	sml_filter(NULL);
    }
    toplevel_close();

    return 0;
}
