#include <stdio.h>
#include <spa.h>
#include "tagfixes.h"


main (int argc, char *argv[])
{
    int compile = 0, showdefaults = 0;
    char *inpath = NULL, *outpath = NULL, *fxpath = DEFAULT_FX_FILE;
    FILE *infile = stdin, *outfile = stdout;
    struct tagfixes *fx;

    defaults(fxpath, "TAGFIXES");

    Usage = "tagfixes [options] [filename]\n\
tagfixes -c [filename]\n\
\n\
Without -c: apply a tagmap to file <filename>.\n\
With -c: compile the tagmap in <filename>.\n\
\n\
Options:\n\
-o <filename>  Filename to write output to.\n\
-f <filename>  Tagmap to use.\n\
-k             Keep old tags: add new tags as a new column.\n\
-cs            Case sensitive: do not ignore case of words.";

    parse_args(&argc, &argv, "?s-so-sf-bc-bs-ia-bk-bcs-bdefaults",
	       &inpath, &outpath, &fxpath, &compile, &TagfixesSilent,
	       &TagFixesAlloc, &KeepOldTags, &WordsCaseSensitive,
	       &showdefaults);

    if (compile) {
	if (inpath == NULL) error("%s: no input file", ProgName);
	compile_tagfixes(inpath);
    }
    else {
	if (fxpath == NULL) error("%s: no fxpath", ProgName);
	fx = load_tagfixes(fxpath);

	if (inpath != NULL) infile = Fopen(inpath, "r");
	if (outpath != NULL) outfile = Fopen(outpath, "w");
	apply_tagfixes(fx, infile, outfile);
    }

    exit(0);
}
