#include <stdio.h>
#include <math.h>
#include <spa.h>


vcmp (char *name)
{
    char filename[MAXFILENAME], test_line[256], std_line[256], smp_line[256];
    int t = 0, s = 0, x = 0, X = 0, N = 0;
    double p, e;
    FILE *test_file, *std_file, *diff_file;

    strcpy(filename, name);
    addsuf(filename, ".tst");
    test_file = Fopen(filename, "r");
    printf("test file                  = %s\n", filename);
    
    chsuf(filename, ".tst", ".std");
    std_file = Fopen(filename, "r");
    printf("std file                   = %s\n", filename);

    chsuf(filename, ".std", ".diff");
    diff_file = Fopen(filename, "w");
    printf("writing diff file          = %s\n", filename);

    terpri(stdout);

    while (scan_line(test_line, 256, test_file) != EOF) {
	if (scan_line(std_line, 256, std_file) == EOF) {
	    error("Premature EOF in std file");
	}
	if (*test_line) t++;
	if (*std_line) s++;
	if (string_equal(test_line, std_line)) {
	    X++;
	    if (*test_line) x++;
	}
	else fprintf(diff_file, "%d\n", N);
	N++;
    }
    if (peek_char(std_file) != EOF) error("Premature EOF in test file");
    if (N == 0) {
	printf("Empty files\n");
    }
    else {
	printf("sample size:             N = %d\n", N);
	printf("answers in common:       X = %d\n", X);
	printf("nonzeros in test:        t = %d\n", t);
	printf("nonzeros in std:         s = %d\n", s);
	printf("nonzeros in common:      x = %d\n", x);
	printf("\n");

	p = (double)X/N;
	e = 1.96 * sqrt(X*(1-p)) / N;
	printf("per-word accuracy:     X/N = %d/%d = %f +- %f\n", X, N, p, e);
	e = .01;
	printf("N for 1%% error             = %d\n\n", (int)(1.96*1.96*p*(1-p)/(e*e) + .5));

	/* sig=sqrt(xq)/n.  95% Normal = 1.96.  */
	p = (double)x/t;
	e = 1.96 * sqrt(x*(1-p)) / t;
	printf("precision:             x/t = %d/%d = %f +- %f\n", x, t, p, e);
	e = .01;
	printf("N for 1%% error             = %d\n\n", (int)((1.96*1.96*p*(1-p)/(e*e))*N/t + .5));

	p = (double)x/s;
	e = 1.96 * sqrt(x*(1-p)) / s;
	printf("recall:                x/s = %d/%d = %f +- %f\n", x, s, p, e);
	e = .01;
	printf("N for 1%% error             = %d\n\n", (int)((1.96*1.96*p*(1-p)/(e*e))*N/s + .5));

	printf("\n");
	printf("false alarms:          t-x = %d\n", t-x);
	printf("misses:                s-x = %d\n", s-x);
	printf("false alarm rate:  (t-x)/N = %f\n", (double)(t-x)/N);
	printf("miss rate:         (s-x)/N = %f\n", (double)(s-x)/N);
    }
}


main (int argc, char *argv[])
{
    char *name;

    parse_args(&argc, &argv, "s", &name);

    vcmp(name);
}
