#include <spa.h>
#include <amgr.h>

int prinfloat (float *fp, FILE *file)
{
    fprintf(file, "%.3f", *fp);
}

main ()
{
    float f, *a;
    struct amgr *Mgr;
    int i;
    FILE *file;

    Mgr = make_amgr(&a, 5, sizeof(float));

    dump_amgr(Mgr, &prinfloat, stdout);

    f = 1.5;
    gpush(&f, Mgr);
    f = -12;
    gpush(&f, Mgr);

    terpri(stdout);
    dump_amgr(Mgr, &prinfloat, stdout);

    gneed(Mgr, 5);
    a[4] = 6.662;

    terpri(stdout);
    dump_amgr(Mgr, &prinfloat, stdout);

    terpri(stdout);
    printf("gnew = %d\n", i = gnew(Mgr));
    a[i] = 220.5;
    dump_amgr(Mgr, &prinfloat, stdout);

    file = Fopen("amgr.tmp.1", "w");
    write_amgr(Mgr, file);
    free_amgr(Mgr);
    fclose(file);

    file = Fopen("amgr.tmp.1", "r");
    Mgr = read_amgr(&a, file);
    terpri(stdout);
    dump_amgr(Mgr, &prinfloat, stdout);
    printf("\na[6] = %.3f\n", a[6]);

    system("rm amgr.tmp.1");

    return 0;
}

    
