#include <spa.h>
#include <reg.h>


main (int argc, char *argv[])
{
    char *grammar = NULL, *outpath = NULL;
    int compile = 0, print = 0, tms = 0;
    FILE *outfile = stdout;

    defaults(grammar, "CASS_GRAMMAR");

#ifdef DEBUG
    debug_on_error = 1;
#endif

    parse_args(&argc, &argv, "?s-so-bc-bp-bm",
	       &grammar, &outpath, &compile, &print, &tms);

    if (grammar == NULL) error("%s: No grammar, no default", ProgName);
    if (outpath != NULL) outfile = Fopen(outpath, "w");

    if (!(compile || print || tms)) compile = 1;

    printf("Compiling %s\n", grammar);
    if (compile) compile_reg(grammar, NULL);

    printf("\nFreeing, then re-loading %s\n", FscFilename);
    free_reg();
    load_fsc(FscFilename);
    dump_fsc(NULL, stdout);

    rm(FscFilename);

    return 0;
}
