#include <spa.h>
#include <regdict.h>


main (int argc, char *argv[])
{
    char *filename = NULL;
    FILE *file = stdin;
    struct tokstream *stream;
    
    parse_args(&argc, &argv, "?s", &filename);

    if (filename != NULL) file = Fopen(filename, "r");

    stream = make_tokstream(file);
    scan_att_decls(stream);

    intern_tag(intern("n"), INPUT);
    intern_tag(intern("nbar"), ACT_LEFT);
    intern_tag(intern("h"), ACT_ASSIGN);
    intern_tag(intern("np"), OUTPUT);

    dump_regdict(stdout);

    printf("\nWriting to regdict.tmp.dict and re-reading\n");
    file = Fopen("regdict.tmp.dict", "w");
    write_regdict(file);
    fclose(file);
    free_regdict();

    file = Fopen("regdict.tmp.dict", "r");
    read_regdict(file);
    fclose(file);

    dump_regdict(stdout);

    printf("\nDeleting regdict.tmp.dict\n");
    rm("regdict.tmp.dict");

    return 0;
}
