#include <spa.h>
#include <regfsa.h>


main (int argc, char *argv[])
{
    char *filename = NULL;
    FILE *file;
    struct tokstream *stream;
    RegexId rx;
    FsaId fsa;
    int i;

    parse_args(&argc, &argv, "?s", &filename);
    if (filename != NULL) stream = open_tokstream(filename);
    else stream = make_tokstream(stdin);

    rx = scan_regex(stream);
    RegTraceTM = 1;

    if (Fsas == NULL) init_fsas();
    fsa = new_fsa();
    fsa_cat(fsa) = regex_cat(rx);
    make_maps(fsa, rx);
    print_maps(stdout);

    make_transition_matrix(fsa, rx);
    terpri(stdout);
    printf("TM:\n");
    print_tm(stdout);

    terpri(stdout);
    dump_fsa_stores(stdout);

    terpri(stdout);
    printf("Writing and re-reading regfsa.tmp.fsas\n");
    file = Fopen("regfsa.tmp.fsas", "w");
    write_fsas(file);
    fclose(file);
    free_fsas();
    file = Fopen("regfsa.tmp.fsas", "r");
    read_fsas(file);
    dump_fsa_stores(stdout);

    use_fsa(1);

    print_maps(stdout);
    printf("TM:\n");
    print_tm(stdout);

    rm("regfsa.tmp.fsas");

    return 0;
}
